
IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'PadL'
                    AND type = 'FN' ) 
    DROP FUNCTION dbo.PadL
GO

CREATE FUNCTION [dbo].[PadL](@nvalor INTEGER, @cvalor VARCHAR(100), @nlen INTEGER, @cchar CHAR(1))

RETURNS VARCHAR(500)

AS

BEGIN

  DECLARE @creturn VARCHAR(500)

  IF @nvalor IS NOT NULL
    SET @creturn = LTRIM(RTRIM(CONVERT(VARCHAR(500),@nvalor)))
  ELSE
    SET @creturn = LTRIM(RTRIM(@cvalor))


  IF LEN(@creturn) < @nlen
    SET @creturn = REPLICATE(@cchar,@nlen - LEN(@creturn)) + @creturn
  ELSE
    SET @creturn = LEFT(@creturn,@nlen)

  RETURN (@creturn)

END


GO
IF NOT EXISTS ( SELECT *
                 FROM   dbo.sysobjects
                 WHERE  id = OBJECT_ID(N'[dbo].[CatalogoComentarios]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
	CREATE TABLE [dbo].[CatalogoComentarios](
		[idComentario] [bigint] NOT NULL,
		[texto] [varchar](500) NULL,
		[tipo] [varchar](25) NULL,
		[idEmpresa] [char](10) NULL,
	 CONSTRAINT [PK_CatalogoComentarios] PRIMARY KEY CLUSTERED 
	(
		[idComentario] ASC
	)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
	) ON [PRIMARY]
	end 
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'[dbo].[EncryptaPassword]')
                    AND xtype IN ( N'FN', N'IF', N'TF' ) ) 
    DROP FUNCTION [dbo].EncryptaPassword

GO

CREATE FUNCTION [dbo].EncryptaPassword
    (
      @password AS VARCHAR(30)
    )
RETURNS VARCHAR(30)
    WITH ENCRYPTION
AS 
    BEGIN

        DECLARE @vClave AS udtName

        SET @vClave = @password

        DECLARE @nCtr AS udtInteger ,
            @nTemp AS udtInteger ,
            @nOffset AS udtInteger ,
            @sPwdTemp AS udtName ,
            @sCodTemp AS udtName

        SET @sPwdTemp = @vClave
        SET @sCodTemp = ''
        SET @nCtr = 1
   
        WHILE @nCtr <= LEN(@sPwdTemp) 
            BEGIN
                SET @nOffset = @nCtr % 3
                SET @nTemp = ASCII(SUBSTRING(@sPwdTemp, @nCtr, 1))
                SET @sCodTemp = @sCodTemp + CHAR(( @nTemp + 10 - @nOffset ))
                SET @nCtr = @nCtr + 1
            END

        RETURN( @sCodTemp )

    END
GO

 IF EXISTS ( SELECT name
             FROM   sysobjects
             WHERE  name = 'ObtenRelojValidaPassword'
                    AND type = 'P' ) 
    DROP PROCEDURE ObtenRelojValidaPassword
GO

 CREATE PROCEDURE ObtenRelojValidaPassword
    (
      @username AS udtName , --sin guiones ni espacios
      @password AS udtName
    )
	----WITH ENCRYPTION
 AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    SET XACT_ABORT ON
    DECLARE @passwordDecrypt AS udtName
    DECLARE @passwordUser AS udtName
    DECLARE @userValid AS udtName
	
	
    SET @userValid = ISNULL(( SELECT    'Found'
                              FROM      dbo.usuarios
                              WHERE     usuario = @username
                            ), 'Not')
    IF @userValid = 'Not' 
        BEGIN
            SELECT  'UserNotFound' AS cLogin
		
        END
    ELSE 
        BEGIN
	
		
		
            SET @passwordUser = ( SELECT    password
                                  FROM      dbo.usuarios
                                  WHERE     usuario = @username
                                )
		
            SELECT  CASE WHEN BINARY_CHECKSUM(@passwordUser) = BINARY_CHECKSUM(@password)
                         THEN 'LoginSuccessfully'
                         WHEN BINARY_CHECKSUM(@passwordUser) <> BINARY_CHECKSUM(@password)
                         THEN 'IncorrectPassarod'
                    END AS cLogin
		
        END 
	
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'[dbo].[DesencryptaPassword]')
                    AND xtype IN ( N'FN', N'IF', N'TF' ) ) 
    DROP FUNCTION [dbo].DesencryptaPassword

GO

CREATE FUNCTION [dbo].DesencryptaPassword
    (
      @password AS VARCHAR(30)
    )
RETURNS VARCHAR(30)
    WITH ENCRYPTION
AS 
    BEGIN

        DECLARE @vClave AS udtName

        SET @vClave = @password

        DECLARE @nCtr AS udtInteger ,
            @nTemp AS udtInteger ,
            @nOffset AS udtInteger ,
            @sPwdTemp AS udtName ,
            @sCodTemp AS udtName

        SET @sPwdTemp = @vClave
        SET @sCodTemp = ''
        SET @nCtr = 1
   
        WHILE @nCtr <= LEN(@sPwdTemp) 
            BEGIN
                SET @nOffset = @nCtr % 3
                SET @nTemp = ASCII(SUBSTRING(@sPwdTemp, @nCtr, 1))
                SET @sCodTemp = @sCodTemp + CHAR(( @nTemp + 10 - @nOffset ))
                SET @nCtr = @nCtr + 1
            END

        RETURN( @sCodTemp )

    END
GO

IF EXISTS ( SELECT  name
            FROM    sysobjects
            WHERE   name = 'ObtenRelojEmpresas'
                    AND type = 'P' ) 
    DROP PROCEDURE ObtenRelojEmpresas
GO

CREATE PROCEDURE ObtenRelojEmpresas ( @username AS udtName )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debug udtInteger

    DECLARE @cEmpresas udtStringSize255
	
    SET @debug = 0
    SET @whereClauseUsed = 0
    SET @whereClause = ''
    SET @orderByClause = ''
    SET @groupByClause = ''


    SELECT  @cEmpresas = b.empresas
    FROM    perfil_usuarios AS a
            INNER JOIN perfiles AS b ON a.idperfil = b.idperfil
    WHERE   a.usuario = @username
            AND b.sistema = 'RC'
    
    IF LEN(@cEmpresas) > 0 
        BEGIN
            SET @cEmpresas = REPLACE(@cEmpresas, '{', '(')
            SET @cEmpresas = REPLACE(@cEmpresas, '}', ')')
        END 
    ELSE 
        BEGIN
            SET @cEmpresas = '()'
        END 
	
    IF @cEmpresas <> '()' 
        BEGIN
    
            IF @whereClauseUsed = 0 
                BEGIN
	       
                    SET @whereClause = @whereClause + 'WHERE '
                    SET @whereClauseUsed = 1

                END
            ELSE 
                SET @whereClause = @whereClause + ' AND '
	                 
            SET @whereClause = @whereClause + 'empresa in' + @cEmpresas
                 
        END
	
    SET @selectClause = 'SELECT empresa,'
        + 'case when referencia is null or len(rtrim(ltrim(referencia)))<=0 then nombre_empresa else referencia end as nombre_empresa,'
        + 'nombre_empresa,' + 'registro_patronal,' + 'rfc_empresa '
    						
    SET @fromClause = 'FROM    empresas '
        
    IF @debug = 0 
        BEGIN 
            EXEC(
            @selectClause + @fromClause + @whereClause + @groupByClause + @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END


GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenValidaUsuario'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenValidaUsuario
GO

CREATE PROCEDURE dbo.ObtenValidaUsuario
    (
      @username udtName ,
      @password udtStringSize512 ,
      @date udtDateTime ,
      @tipo udtName
    )
    WITH ENCRYPTION
AS 
    DECLARE @validUser udtName
    DECLARE @validPass udtName
    DECLARE @userNameFull udtName
    DECLARE @userId udtLong
    DECLARE @admin udtName
    DECLARE @empresa udtInteger
    DECLARE @dateExpire udtDateTime
    
	SET @userNameFull = ''
    SET @userId = 0
    SET @admin = ''
    
    IF @tipo = 'NOM' 
        BEGIN
            SET @validUser = CASE WHEN ISNULL(( SELECT  'T'
                                                FROM    dbo.usuarios
                                                WHERE   usuario = @username
                                              ), 'F') = 'T' THEN 'T'
                                  ELSE 'F'
                             END 
            IF @validUser = 'T' 
                BEGIN
                    SET @dateExpire = ( SELECT  expiracion
                                        FROM    dbo.usuarios
                                        WHERE   usuario = @username
                                      )
                    SET @validUser = CASE WHEN @date > ISNULL(@dateExpire,
                                                              @date) THEN 'F'
                                          ELSE @validUser
                                     END
                   
                END
            SET @validPass = CASE WHEN @validUser = 'T'
                                       AND ISNULL(( SELECT  'T'
                                                    FROM    dbo.usuarios
                                                    WHERE   password = ( SELECT
                                                              [dbo].EncryptaPassword(@password)
                                                              )
                                                            AND usuario = @username
                                                  ), 'F') = 'T' THEN 'T'
                                  ELSE 'F'
                             END 
            SET @empresa = 0
        END
    ELSE 
        BEGIN    
            IF @tipo = 'SUP' 
                BEGIN
                    SET @empresa = ( SELECT s.empresa
                                     FROM   dbo.supervisores AS s
                                            INNER JOIN dbo.empleados AS e ON s.empresa = e.empresa
                                                              AND s.codigo = e.codigo
                                     WHERE  s.supervisor = CAST(@username AS BIGINT)
                                            AND e.activo = 'S'
                                            AND CASE WHEN s.passwordPortal IS NULL
                                                          OR LEN(s.passwordPortal) <= 0
                                                     THEN ( SELECT
                                                              [dbo].EncryptaPassword(e.rfcalfa
                                                              + CONVERT(CHAR(6), e.rfcnum)
                                                              + e.rfchomo)
                                                          )
                                                     ELSE s.passwordPortal
                                                END = ( SELECT
                                                              [dbo].EncryptaPassword(@password)
                                                      )
                                   )
		
                    IF ISNULL(@empresa, 0) <= 0 
                        BEGIN
                            SET @validUser = 'F'
                            SET @validPass = 'F'
                        END 
                    ELSE 
                        BEGIN
                            SET @validUser = 'T'
                            SET @validPass = 'T'
                        END 
                END
    
            ELSE 
                BEGIN
                    SET @empresa = ( SELECT empresa
                                     FROM   dbo.empleados
                                     WHERE  codigo = CAST(@username AS BIGINT)
                                            AND CASE WHEN password_empleado IS NULL
                                                          OR LEN(password_empleado) <= 0
                                                     THEN ( SELECT
                                                              [dbo].EncryptaPassword(afiliacion)
                                                          )
                                                     ELSE password_empleado
                                                END = ( SELECT
                                                              [dbo].EncryptaPassword(@password)
                                                      )
                                   )
		
                    IF ISNULL(@empresa, 0) <= 0 
                        BEGIN
                            SET @validUser = 'F'
                            SET @validPass = 'F'
                        END 
                    ELSE 
                        BEGIN
                            SET @validUser = 'T'
                            SET @validPass = 'T'
                        END 
                END
        END
	
    SELECT  CASE WHEN @validUser = 'F'
                      OR @validPass = 'F'
                 THEN 'EL USUARIO O PASSWORD ES INCORRECTO'
                 WHEN @validUser = 'T'
                      AND @validPass = 'T' THEN 'CORRECTO'
            END AS loginMessage ,
            ISNULL(@empresa, 0) 

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.Obras_param')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.Obras_param
            (
              [empresa] [numeric](3, 0) NOT NULL ,
              [tipo_carga] INTEGER ,
              CONSTRAINT [PK_Obras_param] PRIMARY KEY CLUSTERED
                ( [empresa] ASC )
            )
        ON  [PRIMARY]


    END

GO


IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'Obras')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.Obras
            (
              [obra] [numeric](18, 0) NOT NULL ,
              [empresa] [numeric](3, 0) NOT NULL ,
              [nombre] [varchar](30) NULL ,
              [razon_social] [varchar](70) NULL ,
              [registro_patronal] [char](11) NULL ,
              [calle] [varchar](30) NULL ,
              [n_interior] [int] NULL ,
              [n_exterior] [int] NULL ,
              [colonia] [varchar](30) NULL ,
              [municipio] [varchar](30) NULL ,
              [cp] [int] NULL ,
              [localidad] [varchar](30) NULL ,
              [ent_fed] [varchar](30) NULL ,
              [estatus] [char](2) NULL ,
              CONSTRAINT [PK_OBRAS] PRIMARY KEY CLUSTERED
                ( [obra] ASC, [empresa] ASC )
            )
        ON  [PRIMARY]


    END

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'Obras_Emps')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    CREATE TABLE [dbo].[Obras_emps]
        (
          [Obra] [numeric](18, 0) NOT NULL ,
          [empresa] [numeric](3, 0) NOT NULL ,
          [codigo] [numeric](8, 0) NOT NULL ,
          [fecha_i] [datetime] NOT NULL ,
          [fecha_f] [datetime] NOT NULL ,
          [supervisor] [int] NOT NULL ,
          [dias] [int] NOT NULL ,
          [mes] [int] NOT NULL ,
          [ayo] [int] NOT NULL ,
          [serial] [int] IDENTITY(1, 1)
                         NOT NULL ,
          CONSTRAINT [PK_Obras_emps] PRIMARY KEY CLUSTERED
            ( [Obra] ASC, [empresa] ASC, [codigo] ASC, [mes] ASC, [ayo] ASC, [serial] ASC )
        )
    ON  [PRIMARY]

GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'Obras_SinObra')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    CREATE TABLE [dbo].[Obras_SinObra]
        (
          [empresa] [numeric](3, 0) NOT NULL ,
          [codigo] [numeric](8, 0) NOT NULL ,
          [SinObra] [int] 
                         NOT NULL ,
          CONSTRAINT [PK_Obras_SinObra] PRIMARY KEY CLUSTERED
            ( [empresa] ASC, [codigo] ASC)
        )
    ON  [PRIMARY]

GO


IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.Obras_Categorias')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.Obras_Categorias
            (
              [categoria] INT NOT NULL ,
              [nombre] VARCHAR(30) ,
              CONSTRAINT [PK_Obras_Categorias] PRIMARY KEY CLUSTERED
                ( [categoria] ASC )
            )
        ON  [PRIMARY]
        
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 1, 'AYUDANTE' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 2, 'AYUDANTES CALIFICADOS' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 3, 'OFICIALES' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 4, 'OFICIALES CALIFICADOS' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 5, 'OPERADORES' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 6, 'PEONES' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 7, 'SUPERVISORES' )


    END
    
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.Obras_SubCategorias')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.Obras_SubCategorias
            (
              [sub_categoria] INT NOT NULL ,
              [nombre] VARCHAR(40) ,
              CONSTRAINT [PK_Obras_SubCategorias] PRIMARY KEY CLUSTERED
                ( [sub_categoria] ASC )
            )
        ON  [PRIMARY]
        
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 1, 'Ayudante' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 2, 'Ayudante de Aforador' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 3, 'Ayudante de Albailera' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 4, 'Ayudante de Aluminero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 5, 'Ayudante de Azulejero ' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 6, 'Ayudante de Cantero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria ,
                  nombre 
                )
        VALUES  ( 7 ,
                  'Ayudante de Carpintero de Banco'
                )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria ,
                  nombre 
                )
        VALUES  ( 8 ,
                  'Ayudante de Carpintero de Obra Negra'
                )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 9, 'Ayudante de Elctrico' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 10, 'Ayudante de Fierrero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 11, 'Ayudante de Herrero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 12, 'Ayudante de Instalacin' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 13, 'Ayudante de Jardinero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 14, 'Ayudante de Mosaiquero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 15, 'Ayudante de Operador' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 16, 'Ayudante de Pastero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria ,
                  nombre 
                )
        VALUES  ( 17 ,
                  'Ayudante de Perforador (chango)'
                )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 18, 'Ayudante de Pintor' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 19, 'Ayudante de Piso' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 20, 'Ayudante de Plomero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 21, 'Ayudante de Radiolgo' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 22, 'Ayudante de Topgrafo' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 23, 'Ayudante de Tubero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 24, 'Ayudante de Vidriero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 25, 'Ayudante de Yesero' )


    END
    
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'dbo.Obras_EmpleadosCategorias')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    BEGIN
        CREATE TABLE dbo.Obras_EmpleadosCategorias
            (
              [empresa] INT NOT NULL ,
              [codigo] INT NOT NULL ,
              [categoria] INT NOT NULL ,
              [sub_categoria] INT NOT NULL ,
              CONSTRAINT [PK_Obras_EmpleadosCategorias] PRIMARY KEY CLUSTERED
                ( [empresa], [codigo], [categoria], [sub_categoria] ASC )
            )
        ON  [PRIMARY]
    END
    
GO


IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'saldiaint'
                        AND sysobjects.name = 'Obras_Emps' ) 
    ALTER TABLE Obras_Emps ADD saldiaint NUMERIC(10,2)

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'sueldo'
                        AND sysobjects.name = 'Obras_Emps' ) 
    ALTER TABLE Obras_Emps ADD sueldo NUMERIC(10,2)

GO


	--select * from obras
INSERT  INTO dbo.Obras
        ( obra ,
          empresa ,
          nombre ,
          razon_social ,
          registro_patronal ,
          calle ,
          n_interior ,
          n_exterior ,
          colonia ,
          municipio ,
          cp ,
          localidad ,
          ent_fed ,
          estatus
        )
        SELECT  0 ,
                a.empresa ,
                'SIN OBRA' ,
                '' ,
                '' ,
                '' ,
                0 ,
                0 ,
                '' ,
                '' ,
                0 ,
                '' ,
                '' ,
                'A'
        FROM    dbo.empresas AS a
        WHERE   NOT  a.empresa IN ( SELECT DISTINCT
                                            ( empresa )
                                   FROM     obras
                                   WHERE    obra = 0 ) 
	
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[trabajadores_mes]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    CREATE TABLE [dbo].[trabajadores_mes]
        (
          [empresa] [numeric](5, 0) NOT NULL ,
          [codigo] [numeric](8, 0) NOT NULL ,
          [fch_ini] [datetime] NOT NULL ,
          [fch_fin] [datetime] NOT NULL ,
          [dias] [int] NULL ,
          [dias_disponibles] [int] NULL ,
          [aus] [int] NULL ,
          [inc] [int] NULL ,
          [mes] [int] NULL ,
          [ayo] [int] NULL
        )
    ON  [PRIMARY]
go

IF OBJECT_ID('pk_trabajadores_mes') IS NULL 
    ALTER TABLE [dbo].[trabajadores_mes] ADD
    CONSTRAINT [PK_trabajadores_mes] PRIMARY KEY  CLUSTERED
    (
    [empresa],
    [codigo],
    [fch_ini],
    [fch_fin]
    )

go


IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'saldiaint'
                        AND sysobjects.name = 'trabajadores_mes' ) 
    ALTER TABLE trabajadores_mes ADD saldiaint NUMERIC(10,2)

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'sueldo'
                        AND sysobjects.name = 'trabajadores_mes' ) 
    ALTER TABLE trabajadores_mes ADD sueldo NUMERIC(10,2)

GO

ALTER TABLE [dbo].[OBRAS]
ALTER COLUMN [nombre] VARCHAR(50) NULL

GO 


IF OBJECT_ID('dbo.ObtenEmpresas') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenEmpresas
go

CREATE PROCEDURE dbo.ObtenEmpresas
    WITH ENCRYPTION
AS 
    SELECT  LTRIM(RTRIM(STR(empresa))) AS empresa ,
            CASE WHEN ISNULL(LEN(referencia), 0) <= 0 THEN nombre_empresa
                 ELSE referencia
            END AS nombreEmpresa
    FROM    empresas

GO

IF OBJECT_ID('dbo.ObtenPortalConsObras') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalConsObras
go

CREATE PROCEDURE dbo.ObtenPortalConsObras
    (
      @companyId udtInteger
    )
    WITH ENCRYPTION
AS 
    SELECT  obra ,
            nombre ,
            estatus
    FROM    obras
    WHERE   empresa = @companyId
			and obra <>'0'

GO


IF OBJECT_ID('dbo.ObtenPortalConsEmpsEnObras') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalConsEmpsEnObras
go

CREATE PROCEDURE dbo.ObtenPortalConsEmpsEnObras
    (
      @companyId udtInteger ,
      @workId udtLong
    )
    WITH ENCRYPTION
AS 
    SELECT  b.codigo ,
            d.nombre + ' ' + d.ap_paterno + ' ' + d.ap_materno AS nombre ,
            CONVERT(NVARCHAR(30), b.fecha_i, 103) AS fecha_i ,
            CONVERT(NVARCHAR(30), d.fchalta, 103) AS fchalta
    FROM    obras AS a
            INNER JOIN obras_emps AS b ON a.empresa = b.empresa
                                          AND a.obra = b.obra
            INNER JOIN empleados AS d ON b.empresa = d.empresa
                                         AND b.codigo = d.codigo
    WHERE   a.obra = @workId
            AND b.empresa = @companyId
    GROUP BY b.codigo ,
            b.fecha_i ,
            d.nombre ,
            d.ap_paterno ,
            d.ap_materno ,
            d.fchalta
    ORDER BY b.codigo ,
            b.fecha_i
         
GO

IF OBJECT_ID('dbo.ObtenDetalleEmpresaHistoricos') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenDetalleEmpresaHistoricos
go

CREATE PROCEDURE dbo.ObtenDetalleEmpresaHistoricos
    (
      @companyId udtInteger
    )
    WITH ENCRYPTION
AS 
    SELECT  nombre_empresa ,
            rfc_empresa ,
            registro_patronal ,
            SUBSTRING(registro_patronal, LEN(registro_patronal), 1) AS dig ,
            mes_operacion ,
            ayo_operacion
    FROM    empresas
    WHERE   empresa = @companyId 

GO


IF OBJECT_ID('dbo.ObtenPortalConsNvaObra') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalConsNvaObra
go

CREATE PROCEDURE dbo.ObtenPortalConsNvaObra
    (
      @companyId udtInteger     
    )
    WITH ENCRYPTION
AS 
    SELECT  ISNULL(MAX(obra), 0) + 1 AS nva_obra
    FROM    obras
    WHERE   empresa = @companyId
GO


IF OBJECT_ID('dbo.ObtenPortalConsDetalleObra') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalConsDetalleObra
go

CREATE PROCEDURE dbo.ObtenPortalConsDetalleObra
    (
      @empresa udtInteger ,
      @Obra udtLong
    )
    WITH ENCRYPTION
AS 
    SELECT  obra ,
            empresa ,
            nombre ,
            razon_social ,
            registro_patronal ,
            calle ,
            n_interior ,
            n_exterior ,
            colonia ,
            municipio ,
            cp ,
            localidad ,
            ent_fed ,
            estatus
    FROM    obras
    WHERE   obra = @obra
            AND empresa = @empresa
         
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'asp_trabajadores_del_mes'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.asp_trabajadores_del_mes
    
GO

CREATE PROCEDURE dbo.asp_trabajadores_del_mes
    (
		@nempresa NUMERIC(5, 0) ,
		@nmes INT ,
		@nayo INT ,
		@reimporta VARCHAR(1)
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	declare @NoIncluir as table(empresa int, codigo bigint)
	insert into @NoIncluir
	select empresa,codigo
	from dbo.Obras_SinObra
	where empresa=@nempresa and SinObra = 1

    DECLARE @trabajadores_mes AS TABLE
        (
          empresa udtInteger ,
          codigo udtInteger ,
          fch_ini udtDateTime ,
          fch_fin udtDateTime ,
          dias udtInteger ,
          aus udtInteger ,
          inc udtInteger ,
          mes udtInteger ,
          ayo udtInteger ,
          sueldo NUMERIC(10, 2) ,
          saldiaint NUMERIC(10, 2) ,
          dias_disponibles udtInteger
        )
    DECLARE @count INT
    SELECT  @count = COUNT(1)
    FROM    trabajadores_mes
    WHERE   empresa = @nempresa
            AND mes = @nmes
            AND ayo = @nayo
    PRINT @count

    IF @count <= 0
        OR @reimporta = 'S'
        OR @count IS NULL 
        BEGIN
            DECLARE @dff DATETIME
            SET @dff = dbo.fin_mes(@nmes, @nayo)

            DELETE  @trabajadores_mes
            WHERE   ayo = @nayo
                    AND mes = @nmes
            DELETE  dbo.Obras_Emps
            WHERE   ayo = @nayo
                    AND mes = @nmes

            INSERT  INTO @trabajadores_mes
                    ( empresa ,
                      codigo ,
                      fch_ini ,
                      fch_fin ,
                      dias ,
                      aus ,
                      inc ,
                      mes ,
                      ayo ,
                      sueldo ,
                      saldiaint
                    )
                    ( SELECT    @nempresa ,
                                a.codigo ,
                                a.fch_mov ,
                                ISNULL(( SELECT TOP 1
                                                b.fch_mov
                                         FROM   avisos_imss AS b
                                         WHERE  a.empresa = b.empresa
                                                AND a.codigo = b.codigo
                                                AND b.mov = 'B'
                                                AND b.mes_operacion = a.mes_operacion
                                                AND b.ayo_operacion = a.ayo_operacion
                                                AND b.fch_mov >= a.fch_mov
                                         ORDER BY b.fch_mov ASC
                                       ), @dff) ,
                                0 ,
                                0 ,
                                0 ,
                                @nmes ,
                                @nayo ,
                                a.sueldo ,
                                saldiaint
                      FROM      dbo.avisos_imss AS a
                      WHERE     a.empresa = @nempresa
                                AND ( a.mov = 'IM'
                                      OR a.mov = 'A'
                                      OR a.mov = 'RI'
                                    )
                                AND a.mes_operacion = @nmes
                                AND a.ayo_operacion = @nayo
                    )

            UPDATE  @trabajadores_mes
            SET     dias = DATEDIFF(dd, fch_ini, fch_fin) + 1 ,
					dias_disponibles = DATEDIFF(dd, fch_ini, fch_fin) + 1 ,
                    aus = 0 ,
                    inc = 0
            WHERE   empresa = @nempresa
                    AND ayo = @nayo
                    AND mes = @nmes


            SELECT  t.empresa ,
                    t.codigo ,
                    t.fch_ini ,
                    t.fch_fin ,
                    CASE WHEN d.num_conc = 108
                         THEN CASE WHEN d.fchinicio <= t.fch_ini
                                        AND d.fchtermino >= t.fch_ini
                                        AND d.fchtermino <= t.fch_fin
                                   THEN DATEDIFF(dd, t.fch_ini, d.fchtermino)
                                        + 1
                                   WHEN d.fchinicio >= t.fch_ini
                                        AND d.fchtermino <= t.fch_fin
                                   THEN d.dias
                                   WHEN d.fchinicio >= t.fch_ini
                                        AND d.fchinicio <= t.fch_fin
                                        AND d.fchtermino >= t.fch_fin
                                   THEN DATEDIFF(dd, d.fchinicio, t.fch_fin)
                                        + 1
                                   WHEN d.fchinicio < t.fch_ini
                                        AND d.fchtermino > t.fch_fin
                                   THEN t.dias
                                   ELSE 0
                              END
                         ELSE 0
                    END AS aus ,
                    CASE WHEN d.num_conc IN ( 109, 110, 111 )
                         THEN CASE WHEN d.fchinicio <= t.fch_ini
                                        AND d.fchtermino >= t.fch_ini
                                        AND d.fchtermino <= t.fch_fin
                                   THEN DATEDIFF(dd, t.fch_ini, d.fchtermino)
                                        + 1
                                   WHEN d.fchinicio >= t.fch_ini
                                        AND d.fchtermino <= t.fch_fin
                                   THEN d.dias
                                   WHEN d.fchinicio >= t.fch_ini
                                        AND d.fchinicio <= t.fch_fin
                                        AND d.fchtermino >= t.fch_fin
                                   THEN DATEDIFF(dd, d.fchinicio, t.fch_fin)
                                        + 1
                                   WHEN d.fchinicio <= t.fch_ini
                                        AND d.fchtermino >= t.fch_fin
                                   THEN t.dias
                                   ELSE 0
                              END
                         ELSE 0
                    END AS inc--,d.num_conc,d.dias,d.fchinicio,d.fchtermino
            INTO    #tra_tmp_aus
            FROM    @trabajadores_mes AS t
                    INNER JOIN dbo.deducciones AS d ON d.empresa = t.empresa
                                                       AND d.codigo = t.codigo
                                                       AND ( ( d.fchinicio >= t.fch_ini
                                                              AND d.fchinicio <= t.fch_fin
                                                             )
                                                             OR ( d.fchtermino >= t.fch_ini
                                                              AND d.fchtermino <= t.fch_fin
                                                              )
                                                           )
                                                       AND d.num_conc IN ( 108,
                                                              109, 110, 111 )
                                                       AND ( YEAR(d.fchinicio) = @nayo
                                                             OR YEAR(d.fchtermino) = @nayo
                                                           )
            WHERE   t.empresa = @nempresa
                    AND t.ayo = @nayo
                    AND t.mes = @nmes
            ORDER BY t.codigo

--mmm


            UPDATE  t
            SET     t.aus = CASE WHEN ( SELECT  SUM(aus)
                                        FROM    #tra_tmp_aus AS a
                                        WHERE   a.empresa = t.empresa
                                                AND a.codigo = t.codigo
                                                AND a.fch_ini = t.fch_ini
                                                AND a.fch_fin = t.fch_fin
                                      ) >= 8 THEN 7
                                 ELSE ( SELECT  SUM(aus)
                                        FROM    #tra_tmp_aus AS a
                                        WHERE   a.empresa = t.empresa
                                                AND a.codigo = t.codigo
                                                AND a.fch_ini = t.fch_ini
                                                AND a.fch_fin = t.fch_fin
                                      )
                            END ,
                    t.inc = ( SELECT    SUM(inc)
                              FROM      #tra_tmp_aus AS a
                              WHERE     a.empresa = t.empresa
                                        AND a.codigo = t.codigo
                                        AND a.fch_ini = t.fch_ini
                                        AND a.fch_fin = t.fch_fin
                            )
            FROM    @trabajadores_mes AS t
            WHERE   t.empresa = @nempresa
                    AND t.ayo = @nayo
                    AND t.mes = @nmes 

            DROP TABLE #tra_tmp_aus

            SELECT  *
            INTO    #tmp_trab_meses
            FROM    @trabajadores_mes
            WHERE   empresa = @nempresa
                    AND ayo = @nayo
                    AND mes = @nmes 

            DELETE  dbo.trabajadores_mes
            WHERE   empresa = @nempresa
                    AND ayo = @nayo
                    AND mes = @nmes 


            UPDATE  t
            SET     dias_disponibles = ISNULL(t.dias, 0) - (ISNULL(t.aus, 0)
                    - ISNULL(t.inc, 0)) ,
                    dias = ISNULL(t.dias, 0) - (ISNULL(t.aus, 0) - ISNULL(t.inc,0))
            FROM    dbo.trabajadores_mes AS t
            WHERE   t.empresa = @nempresa
                    AND t.ayo = @nayo
                    AND t.mes = @nmes 


            DROP TABLE #tmp_trab_meses 
			
            INSERT  INTO dbo.trabajadores_mes
                    ( empresa ,
                      codigo ,
                      fch_ini ,
                      fch_fin ,
                      dias ,
                      aus ,
                      inc ,
                      mes ,
                      ayo ,
                      sueldo ,
                      saldiaint ,
                      dias_disponibles
                    )
                    SELECT  empresa ,
                            codigo ,
                            MIN(fch_ini) ,
                            MAX(fch_fin) ,
                            SUM(dias) ,
                            SUM(aus) ,
                            SUM(inc) ,
                            mes ,
                            ayo ,
                            MAX(sueldo) ,
                            MAX(saldiaint) ,
                            SUM(dias_disponibles)
                    FROM    @trabajadores_mes
					where not codigo in(select codigo from @NoIncluir)
                    GROUP BY empresa ,
                            codigo ,
                            mes ,
                            ayo 
                    ORDER BY codigo
              
            --EXEC dbo.asp_trabajadores_Obras @nempresa, @nmes, @nayo     
        END 

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF OBJECT_ID('dbo.asp_trabajadores_Obras') IS NOT NULL 
    DROP PROCEDURE dbo.asp_trabajadores_Obras
go

-- EXEC dbo.asp_trabajadores_Obras 1,3,2009

CREATE PROCEDURE dbo.asp_trabajadores_Obras
--Declare 
    @Empresa INT ,
    @Mes INT ,
    @Ayo INT
AS 

	INSERT  INTO dbo.Obras_Emps
            ( obra ,
              empresa ,
              codigo ,
              fecha_i ,
              fecha_f ,
              dias ,
              mes ,
              ayo ,
              supervisor ,
              sueldo ,
              saldiaint
            )
            SELECT  ISNULL(( SELECT MAX(obra)
                             FROM   dbo.Obras_emps
                             WHERE  empresa = a.empresa
                                    AND codigo = a.codigo
                                    AND fecha_f = ( SELECT  MAX(bb.fecha_f)
                                                    FROM    obras_emps AS bb
                                                    WHERE   bb.empresa = a.empresa
                                                            AND bb.codigo = a.codigo
                                                  )
                           ), 0) AS Obra ,
                    a.empresa ,
                    a.codigo ,
                    a.fch_ini ,
                    a.fch_fin ,
                    a.dias ,
                    a.mes ,
                    a.ayo ,
                    l.supervisor ,
                    a.sueldo ,
                    a.saldiaint
            FROM    dbo.trabajadores_mes AS a
                    INNER JOIN llaves AS l ON a.empresa = l.empresa
                                              AND a.codigo = l.codigo
            WHERE   a.empresa = @Empresa
                    AND a.mes = @Mes
                    AND a.ayo = @ayo
    UPDATE  dbo.trabajadores_mes
    SET     dias_disponibles = 0
    WHERE   empresa = @Empresa
            AND mes = @Mes
            AND ayo = @ayo
SELECT * FROM dbo.trabajadores_mes WHERE   empresa = @Empresa
            AND mes = @Mes
            AND ayo = @ayo

GO

IF OBJECT_ID('dbo.asp_Cons_Asigna_Emps') IS NOT NULL 
    DROP PROCEDURE dbo.asp_Cons_Asigna_Emps
go



CREATE PROCEDURE dbo.asp_Cons_Asigna_Emps
--Declare
    @Obra NUMERIC(18, 0) ,
    @empresa INT ,
    @codigo NUMERIC(8, 0) ,
    @Mes INT ,
    @Ayo INT ,
    @oper CHAR(1) ,
    @tipo CHAR(1) ,
    @centro VARCHAR(14) ,
    @sup INT ,
    @dias INT
AS 

    IF OBJECT_ID('dbo.tmp_obras_emps') IS NOT NULL 
        BEGIN
            DROP TABLE dbo.tmp_obras_emps
        END
    CREATE TABLE dbo.tmp_obras_emps
        (
          [obra] [numeric](18, 0) NOT NULL ,
          [empresa] [numeric](4, 0) NOT NULL ,
          [codigo] [numeric](8, 0) NOT NULL ,
          [mes] [int] NOT NULL ,
          [ayo] [int] NOT NULL ,
          [dias] [int] NOT NULL ,
          [dias_restar] [int] NULL ,
          sueldo NUMERIC(10, 2) ,
          saldiaint NUMERIC(10, 2) ,
          fecha_i DATETIME ,
          fecha_f DATETIME ,
          supervisor INT
        )
    ON  [PRIMARY]

    IF @oper = 'A' 
        BEGIN
            
            DECLARE @oSQLI VARCHAR(8000)
            DECLARE @oSQLS VARCHAR(8000)
            DECLARE @oSQLF VARCHAR(8000)
            DECLARE @oSQLW VARCHAR(8000)
            SET @oSQLI = 'INSERT  INTO dbo.tmp_obras_emps ' + '( obra ,'
                + 'empresa ,' + 'codigo ,' + 'mes ,' + 'ayo ,' + 'dias ,'
                + 'fecha_i ,' + 'fecha_f ,' + 'supervisor ,' + 'sueldo ,'
                + 'saldiaint' + ')'
            SET @oSQLS = 'SELECT  ' + LTRIM(CONVERT(BIGINT, @obra))
                + ' AS obras ,' + 'a.empresa ,' + 'a.codigo ,' + 'a.mes ,'
                + 'a.ayo ,' + 'CASE WHEN ' + LTRIM(STR(@dias))
                + ' > a.dias_disponibles ' + 'THEN a.dias_disponibles '
                + 'WHEN ' + LTRIM(STR(@dias)) + ' < a.dias_disponibles THEN '
                + LTRIM(STR(@dias)) + ' WHEN ' + LTRIM(STR(@dias))
                + ' = a.dias_disponibles THEN ' + LTRIM(STR(@dias))
                + ' END AS dias_finales ,' + 'GETDATE() ,' + 'GETDATE() ,'
                + 'b.supervisor ,' + 'a.sueldo ,' + 'a.saldiaint '
            SET @oSQLF = 'FROM    trabajadores_mes AS a '
                + 'INNER JOIN llaves AS b ON b.empresa = a.empresa '
                + 'AND b.codigo = a.codigo '
            SET @oSQLW = 'WHERE   a.empresa =' + LTRIM(STR(@empresa))
                + CASE WHEN @codigo > 0
                       THEN ' and a.codigo=' + LTRIM(STR(@codigo))
                       WHEN @codigo = 0
                            AND @tipo = 'C'
                       THEN ' and b.centro=' + '''' + @centro + ''''
                       WHEN @codigo = 0
                            AND @tipo = 'S'
                       THEN ' and b.supervisor=' + LTRIM(STR(@sup))
                  END + ' AND a.mes =' + LTRIM(STR(@mes)) + ' AND a.ayo ='
                + LTRIM(STR(@ayo)) + ' AND a.dias_disponibles > 0 ' 
            EXEC(@oSQLI + @oSQLS + @oSQLF + @oSQLW)                            


            PRINT 'Antes Update'
            UPDATE  c
            SET     c.dias_disponibles = c.dias_disponibles
                    - CASE WHEN b.dias > c.dias_disponibles
                           THEN c.dias_disponibles
                           ELSE b.dias
                      END 
            FROM    dbo.obras_emps AS a
                    INNER JOIN dbo.tmp_obras_emps AS b ON b.empresa = a.empresa
                                                          AND b.codigo = a.codigo
                                                          AND b.mes = a.mes
                                                          AND b.ayo = a.ayo
                    INNER JOIN dbo.trabajadores_mes AS c ON c.empresa = b.empresa
                                                            AND c.codigo = b.codigo
                                                            AND c.mes = b.mes
                                                            AND c.ayo = b.ayo
            WHERE   a.empresa = @empresa
                    AND a.mes = @mes
                    AND a.ayo = @ayo
            PRINT 'Despues Update'
            INSERT  INTO dbo.obras_emps
                    ( obra ,
                      empresa ,
                      codigo ,
                      mes ,
                      ayo ,
                      dias ,
                      fecha_i ,
                      fecha_f ,
                      supervisor ,
                      sueldo ,
                      saldiaint
                    )
                    SELECT  obra ,
                            empresa ,
                            codigo ,
                            mes ,
                            ayo ,
                            dias ,
                            fecha_i ,
                            fecha_f ,
                            supervisor ,
                            sueldo ,
                            saldiaint
                    FROM    dbo.tmp_obras_emps
                    
            UPDATE  a
            SET     dias_disponibles = a.dias_disponibles - b.dias
            FROM    dbo.trabajadores_mes AS a
                    INNER JOIN dbo.tmp_obras_emps AS b ON b.empresa = a.empresa
                                                          AND b.codigo = a.codigo
            WHERE   a.empresa = @empresa
                    AND a.mes = @mes
                    AND a.ayo = @ayo
                    
            DELETE  b
            FROM    dbo.obras_emps AS a
                    INNER JOIN dbo.tmp_obras_emps AS b ON b.empresa = a.empresa
                                                          AND b.codigo = a.codigo
                                                          AND b.mes = a.mes
                                                          AND b.ayo = a.ayo
                    INNER JOIN dbo.trabajadores_mes AS c ON c.empresa = b.empresa
                                                            AND c.codigo = b.codigo
                                                            AND c.mes = b.mes
                                                            AND c.ayo = b.ayo
            WHERE   a.empresa = @empresa
                    AND a.mes = @mes
                    AND a.ayo = @ayo
                    AND a.obra = @obra

            INSERT  INTO dbo.obras_emps
                    ( obra ,
                      empresa ,
                      codigo ,
                      mes ,
                      ayo ,
                      dias ,
                      fecha_i ,
                      fecha_f ,
                      supervisor ,
                      sueldo ,
                      saldiaint
                    )
                    SELECT  obra ,
                            empresa ,
                            codigo ,
                            mes ,
                            ayo ,
                            dias ,
                            fecha_i ,
                            fecha_f ,
                            supervisor ,
                            sueldo ,
                            saldiaint
                    FROM    dbo.tmp_obras_emps

        END 


    IF @oper = 'Q' --Marca para quitar empleados en obras
        BEGIN

            INSERT  INTO dbo.tmp_obras_emps
                    ( obra ,
                      empresa ,
                      codigo ,
                      mes ,
                      ayo ,
                      dias
                    )
                    SELECT  @obra AS obras ,
                            a.empresa ,
                            a.codigo ,
                            a.mes ,
                            a.ayo ,
                            CASE WHEN @dias > a.dias THEN a.dias
                                 WHEN @dias < a.dias THEN @dias
                                 WHEN @dias = a.dias THEN a.dias
                            END AS dias_finales
                    FROM    dbo.obras_emps AS a
                            INNER JOIN dbo.llaves AS b ON b.empresa = a.empresa
                                                          AND b.codigo = a.codigo
                    WHERE   a.empresa = @empresa
                            AND ( CASE WHEN @codigo > 0 THEN a.codigo
                                       WHEN @tipo = 'C' THEN b.centro
                                       WHEN @tipo = 'S' THEN b.supervisor
                                  END ) = ( CASE WHEN @codigo > 0 THEN @codigo
                                                 WHEN @tipo = 'C' THEN @centro
                                                 WHEN @tipo = 'S' THEN @sup
                                            END )
                            AND a.mes = @mes
                            AND a.ayo = @ayo
                            AND a.obra = @obra
	
            UPDATE  a
            SET     dias = a.dias - b.dias
            FROM    dbo.obras_emps AS a
                    INNER JOIN dbo.tmp_obras_emps AS b ON b.empresa = a.empresa
                                                          AND b.obra = a.obra
                                                          AND b.codigo = a.codigo
                                                          AND b.mes = a.mes
                                                          AND b.ayo = a.ayo
            WHERE   a.obra = @obra
	
            UPDATE  a
            SET     dias_disponibles = a.dias_disponibles + b.dias
            FROM    dbo.trabajadores_mes AS a
                    INNER JOIN dbo.tmp_obras_emps AS b ON b.empresa = a.empresa
                                                          AND b.codigo = a.codigo
                                                          AND b.mes = a.mes
                                                          AND b.ayo = a.ayo
            WHERE   b.obra = @obra

            DELETE  a
            FROM    dbo.obras_emps AS a
            WHERE   a.obra = @obra
                    AND a.dias <= 0

        END 

    DROP TABLE dbo.tmp_obras_emps

GO


IF OBJECT_ID('dbo.ObtenPortalConsDetalleObra2') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalConsDetalleObra2
go

CREATE PROCEDURE dbo.ObtenPortalConsDetalleObra2
    (
      @companyId udtInteger ,
      @monthId udtInteger ,
      @yearId udtInteger
    )
    WITH ENCRYPTION
AS 
    SELECT  a.obra ,
            a.nombre ,
            ( SELECT    ISNULL(SUM(dias), 0)
              FROM      obras_emps
              WHERE     obra = a.obra
                        AND mes = @monthId
                        AND ayo = @yearId
            ) AS dias
    FROM    dbo.obras AS a
    WHERE   a.empresa = @companyId
            AND a.estatus = 'A'
			and a.obra<>'0'
         
GO

IF OBJECT_ID('dbo.ObtenPortalSupervisoresCentros') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalSupervisoresCentros
go

CREATE PROCEDURE dbo.ObtenPortalSupervisoresCentros
    (
      @companyId udtInteger ,
      @workId udtLong ,
      @monthId udtInteger ,
      @yearId udtInteger ,
      @type udtName
    )
    WITH ENCRYPTION
AS 
    IF @type = 'S' 
        BEGIN
            SELECT  REPLICATE('0', 4 - LEN(c.supervisor))
                    + LTRIM(STR(c.supervisor)) + ' ' + c.nombre AS super
            FROM    dbo.obras_emps AS a
                    INNER JOIN dbo.llaves AS b ON b.empresa = a.empresa
                                                  AND b.codigo = a.codigo
                    INNER JOIN dbo.supervisores AS c ON c.empresa = b.empresa
                                                        AND c.supervisor = b.supervisor
            WHERE   a.obra = @workId
                    AND a.empresa = @companyId
                    AND a.mes = @monthId
                    AND a.ayo = @yearId
            GROUP BY c.supervisor ,
                    c.nombre
        END
    ELSE 
        BEGIN

            SELECT  REPLICATE(' ', 14 - LEN(c.centro)) + c.centro + ' '
                    + c.nomdepto AS super
            FROM    dbo.obras_emps AS a
                    INNER JOIN dbo.llaves AS b ON b.empresa = a.empresa
                                                  AND b.codigo = a.codigo
                    INNER JOIN dbo.centros AS c ON c.empresa = b.empresa
                                                   AND c.centro = b.centro
            WHERE   a.obra = @workId
                    AND a.empresa = @companyId
                    AND a.mes = @monthId
                    AND a.ayo = @yearId
            GROUP BY c.centro ,
                    c.nomdepto
    
        END

GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenPortalConsEmpleadosPorFiltro'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenPortalConsEmpleadosPorFiltro
    
GO



CREATE PROCEDURE dbo.ObtenPortalConsEmpleadosPorFiltro
    (
      @companyId udtInteger ,
      @workId udtLong ,
      @monthId udtInteger ,
      @yearId udtInteger ,
      @type udtName ,
      @value udtNameId
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    SET @debug = 0
    
    SET @selectClause = 'SELECT a.codigo,'
        + 'c.nombre + '' '' + c.ap_paterno + '' '' + c.ap_materno as nombre,'
        + 'a.fecha_i,' + 'a.fecha_f,' + 'a.dias,' + 'b.Supervisor,'
        + 'a.serial '
                      
    SET @fromClause = 'from dbo.obras_emps as a '
        + 'inner join dbo.llaves as b on a.empresa=b.empresa and a.codigo=b.codigo '
        + 'inner join dbo.empleados as c on b.empresa=c.empresa and b.codigo=c.codigo '
    
    SET @whereClause = 'where a.empresa=' + LTRIM(STR(@companyId))
        + ' and a.obra=' + LTRIM(CONVERT(BIGINT, @workId)) + ' and a.mes='
        + LTRIM(STR(@monthId)) + ' and a.ayo=' + LTRIM(STR(@yearId)) + ' and '
        + CASE WHEN @type = 'S' THEN ' b.supervisor= '
               ELSE ' b.centro= '
          END + '''' + @value + ''''
    SET @groupByClause = ''
	
    SET @orderByClause = ''
    
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
    
GO


IF OBJECT_ID('dbo.ObtenPortalSupervisoresCentrosDisp') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalSupervisoresCentrosDisp
go

CREATE PROCEDURE dbo.ObtenPortalSupervisoresCentrosDisp
    (
      @companyId udtInteger ,
      @monthId udtInteger ,
      @yearId udtInteger ,
      @type udtName
    )
    WITH ENCRYPTION
AS 
    IF @type = 'S' 
        BEGIN
            SELECT  REPLICATE('0', 4 - LEN(c.supervisor))
                    + LTRIM(STR(c.supervisor)) + ' ' + c.nombre AS super
            FROM    dbo.trabajadores_mes AS a
                    INNER JOIN dbo.llaves AS b ON b.empresa = a.empresa
                                                  AND b.codigo = a.codigo
                    INNER JOIN dbo.supervisores AS c ON c.empresa = b.empresa
                                                        AND c.supervisor = b.supervisor
            WHERE   a.empresa = @companyId
                    AND a.mes = @monthId
                    AND a.ayo = @yearId
                    AND ISNULL(a.dias_disponibles, a.dias) > 0
            GROUP BY c.supervisor ,
                    c.nombre
        END
    ELSE 
        BEGIN

            SELECT  REPLICATE(' ', 14 - LEN(c.centro)) + c.centro + ' '
                    + c.nomdepto AS super
            FROM    dbo.trabajadores_mes AS a
                    INNER JOIN dbo.llaves AS b ON b.empresa = a.empresa
                                                  AND b.codigo = a.codigo
                    INNER JOIN dbo.centros AS c ON c.empresa = b.empresa
                                                   AND c.centro = b.centro
            WHERE   a.empresa = @companyId
                    AND a.mes = @monthId
                    AND a.ayo = @yearId
                    AND ISNULL(a.dias_disponibles, a.dias) > 0
            GROUP BY c.centro ,
                    c.nomdepto
    
        END

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenPortalConsEmpleadosPorFiltroDisp'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenPortalConsEmpleadosPorFiltroDisp
    
GO



CREATE PROCEDURE dbo.ObtenPortalConsEmpleadosPorFiltroDisp
    (
      @companyId udtInteger ,
      @monthId udtInteger ,
      @yearId udtInteger ,
      @type udtName ,
      @value udtNameId
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    SET @debug = 0
    
    SET @selectClause = 'SELECT a.codigo,'
        + 'c.nombre + '' '' + c.ap_paterno + '' '' + c.ap_materno as nombre,'
        + 'isnull(a.dias_disponibles,a.dias) as disponibles '
                      
    SET @fromClause = 'from dbo.trabajadores_mes as a '
        + 'inner join dbo.llaves as b on a.empresa=b.empresa and a.codigo=b.codigo '
        + 'inner join dbo.empleados as c on b.empresa=c.empresa and b.codigo=c.codigo '
    
    SET @whereClause = 'where a.empresa=' + LTRIM(STR(@companyId))
        + ' and a.mes=' + LTRIM(STR(@monthId)) + ' and a.ayo='
        + LTRIM(STR(@yearId)) + ' and '
        + CASE WHEN @type = 'S' THEN ' b.supervisor= '
               ELSE ' b.centro= '
          END + '''' + @value + ''''
        + '  and isnull(a.dias_disponibles,a.dias)>0 '
    SET @groupByClause = ''
	
    SET @orderByClause = ''
    
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenPortalConsTotales'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenPortalConsTotales
    
GO



CREATE PROCEDURE dbo.ObtenPortalConsTotales
    (
      @companyId udtInteger ,
      @monthId udtInteger ,
      @yearId udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    SET @debug = 0
    
    SET @selectClause = 'select (Select sum(dias) from dbo.trabajadores_mes where empresa='
        + LTRIM(STR(@companyId)) + ' and mes=' + LTRIM(STR(@monthId))
        + ' and ayo=' + LTRIM(STR(@yearId)) + ') as dias,'
        + '(Select sum(dias) from dbo.obras_emps where empresa='
        + LTRIM(STR(@companyId)) + ' and mes=' + LTRIM(STR(@monthId))
        + ' and ayo=' + LTRIM(STR(@yearId)) + ') as aignados,'
        + '(Select sum(dias) from dbo.trabajadores_mes where empresa='
        + LTRIM(STR(@companyId)) + ' and mes=' + LTRIM(STR(@monthId))
        + ' and ayo=' + LTRIM(STR(@yearId)) + ') -'
        + '(Select sum(dias) from dbo.obras_emps where empresa='
        + LTRIM(STR(@companyId)) + ' and mes=' + LTRIM(STR(@monthId))
        + ' and ayo=' + LTRIM(STR(@yearId)) + ') as restan '
                     
    SET @fromClause = ''
    
    SET @whereClause = ''
    SET @groupByClause = ''
	
    SET @orderByClause = ''
    
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
    
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenPortalConsObrasSatics'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenPortalConsObrasSatics
    
GO



CREATE PROCEDURE dbo.ObtenPortalConsObrasSatics
    (
      @companyId udtInteger ,
      @beginMonth udtInteger ,
      @endMonth udtInteger ,
      @yearId udtInteger ,
      @type udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    SET @debug = 0
    SET @selectClause = 'Select replicate(''0'',12 - len(rtrim(ltrim(a.obra))) ) + ltrim(CONVERT(BIGINT,a.obra)) as obra '
                     
    SET @fromClause = 'from dbo.obras_emps as a '
						+ ' inner join obras as b on b.empresa=a.empresa and b.obra=a.obra '
    SET @whereClause = 'where a.empresa=' + LTRIM(STR(@companyId)) 
						+ ' and a.mes = ' + rtrim(ltrim(str(@beginMonth))) 
						+ ' and a.ayo = ' + rtrim(ltrim(str(@yearId))) 
    SET @groupByClause = ' group by replicate(''0'',12 - len(rtrim(ltrim(a.obra))) ) + ltrim(CONVERT(BIGINT,a.obra)) '
	
    SET @orderByClause = ' '
    
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
    
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenPortalConsSatic5'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenPortalConsSatic5
    
GO



CREATE PROCEDURE dbo.ObtenPortalConsSatic5
    (
      @companyId udtInteger ,
      @workId udtLong ,
      @bimId udtInteger ,
      @yearId udtInteger ,
      @type udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    DECLARE @Mes1 udtInteger ,
        @Mes2 udtInteger
    
    IF @type = 1 
        BEGIN
            SET @Mes2 = @bimId * 2
            SET @Mes1 = @Mes2 - 1
        END
    ELSE 
        BEGIN
            SET @Mes1 = @bimId
            SET @Mes2 = 0
        END 
    
    SET @debug = 0
    
    SET @selectClause = 'select replicate(''0'',12-len(a.obra)) + ltrim(CONVERT(BIGINT,a.obra)) as obra, '
        + 'substring(rtrim(ltrim(b.ap_paterno)) + '' '' + rtrim(ltrim(b.ap_materno)) + '' '' + rtrim(ltrim(b.nombre)),1,30) as Nombre,'
        + 'rtrim(ltrim(b.afiliacion)) + rtrim(ltrim(b.digvera)) as Afiliacion,'
        + 'isnull((Select sum(dias) from obras_emps where obra=a.obra and empresa=a.empresa and codigo=a.codigo and mes='
        + LTRIM(STR(@mes1)) + ' and ayo=' + LTRIM(STR(@yearId))
        + '),0) as dMes1,'
        + 'isnull((Select sum(dias) from obras_emps where obra=a.obra and empresa=a.empresa and codigo=a.codigo and mes='
        + LTRIM(STR(@mes2)) + ' and ayo=' + LTRIM(STR(@yearId))
        + '),0) as dMes2,' + 'e.nombre_empresa,' + 'ltrim(str('
        + LTRIM(STR(@bimId)) + ')) as Bimestre,' + 'ltrim(str('
        + LTRIM(STR(@yearId)) + ')) as ayo,'
        + '(isnull((Select sum(dias) from obras_emps where obra=a.obra and empresa=a.empresa and codigo=a.codigo and mes='
        + LTRIM(STR(@mes1)) + ' and ayo=' + LTRIM(STR(@yearId))
        + '),0) * b.saldiaint)+ '
        + '(isnull((Select sum(dias) from obras_emps where obra=a.obra and empresa=a.empresa and codigo=a.codigo and mes='
        + LTRIM(STR(@mes2)) + ' and ayo=' + LTRIM(STR(@yearId))
        + '),0) * b.saldiaint) as importe,' + 'b.saldiaint,'
        + 'REPLICATE(''0'',2-LEN(DAY(GETDATE()))) + LTRIM(STR(DAY(GETDATE()))) AS currentDay,'
        + 'REPLICATE(''0'',2-LEN(MONTH(GETDATE()))) + LTRIM(STR(MONTH(GETDATE()))) AS currentMonth,'
        + 'REPLICATE(''0'',4-LEN(year(GETDATE()))) + LTRIM(STR(year(GETDATE()))) AS currentYear, '
        + 'd.nombre as Categoria,' + 'f.nombre as Sub_Categoria '
                     
    SET @fromClause = 'From dbo.obras_emps as a '
        + 'Inner join dbo.obras as o on a.obra=o.obra AND a.empresa=o.empresa '
        + 'Inner join dbo.empleados as b on a.empresa=b.empresa and a.codigo=b.codigo '
        + 'Inner Join dbo.empresas as e on a.empresa=e.empresa '
        + 'Left join dbo.Obras_EmpleadosCategorias as c on a.empresa=c.empresa and a.codigo=c.codigo '
        + 'inner join dbo.Obras_Categorias as d on d.categoria=c.categoria  '
        + 'inner join dbo.Obras_SubCategorias as f on f.sub_categoria=c.sub_categoria  '
    SET @whereClause = 'where a.empresa=' + LTRIM(STR(@companyId))
        + ' and a.obra=' + LTRIM(CONVERT(BIGINT, @workId)) + ' and a.ayo='
        + LTRIM(STR(@yearId)) + ' and a.mes in(' + LTRIM(STR(@mes1)) + ','
        + LTRIM(STR(@mes2)) + ')'
    SET @groupByClause = ' GROUP BY a.empresa,a.codigo, b.saldiaint, d.nombre,f.nombre, e.nombre_empresa,a.Obra,RTRIM(LTRIM(b.ap_paterno)) , RTRIM(LTRIM(b.ap_materno)), RTRIM(LTRIM(b.nombre)) , RTRIM(LTRIM(b.afiliacion)) + RTRIM(LTRIM(b.digvera)) '
	
    SET @orderByClause = ''
    
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
    
GO

IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[Obras_FromFile]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    CREATE TABLE [dbo].[Obras_FromFile]
        (
          [Obra] [numeric](18, 0) NOT NULL ,
          [empresa] [numeric](3, 0) NOT NULL ,
          [codigo] [numeric](8, 0) NOT NULL ,
          [dias] [int] NOT NULL ,
          [mes] [int] NOT NULL ,
          [ayo] [int] NOT NULL ,
          [periodo] [int] NOT NULL ,
          [inicio] [datetime] NOT NULL ,
          [cierre] [datetime] NOT NULL ,
          CONSTRAINT [PK_Obras_FromFile] PRIMARY KEY CLUSTERED
            ( [Obra] ASC, [empresa] ASC, [codigo] ASC, [periodo] ASC, [mes] ASC, [ayo] ASC )
        )
    ON  [PRIMARY]

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'AgregaPortalIndObrasEmps'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.AgregaPortalIndObrasEmps
    
GO


CREATE PROCEDURE dbo.AgregaPortalIndObrasEmps
    (
      @empresa udtInteger ,
      @mes udtInteger ,
      @ayo udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DELETE  dbo.Obras_emps
    WHERE   mes = @mes
            AND ayo = @ayo
            
    INSERT  dbo.Obras_emps
            ( dias ,
              fecha_i ,
              fecha_f ,
              supervisor ,
              Obra ,
              empresa ,
              codigo ,
              mes ,
              ayo ,
              sueldo ,
              saldiaint 
            )
            SELECT  SUM(a.dias) AS dias ,
                    MIN(a.inicio) AS inicio ,
                    MAX(a.cierre) AS cierre ,
                    0 AS supervisor ,
                    o.obra ,
                    a.empresa ,
                    a.codigo ,
                    a.mes ,
                    ayo ,
                    b.sueldo ,
                    b.saldiaint
            FROM    dbo.Obras_FromFile AS a
                    INNER JOIN dbo.empleados AS b ON a.empresa = b.empresa
                                                     AND a.codigo = b.codigo
                    INNER JOIN dbo.Obras_CentrosRelacion AS o ON a.Obra = CAST(o.clave AS BIGINT)
            WHERE   mes = @mes
                    AND ayo = @ayo
            GROUP BY o.obra ,
                    CAST(o.clave AS BIGINT) ,
                    a.empresa ,
                    a.codigo ,
                    a.mes ,
                    a.ayo ,
                    b.sueldo ,
                    b.saldiaint
                    
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'AgregaPortalIndTrabajadorDesdeArchivo'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.AgregaPortalIndTrabajadorDesdeArchivo
    
GO

CREATE PROCEDURE dbo.AgregaPortalIndTrabajadorDesdeArchivo
    (
      @Obra udtInteger ,
      @empresa udtInteger ,
      @codigo udtInteger ,
      @dias udtInteger ,
      @mes udtInteger ,
      @ayo udtInteger ,
      @periodo udtInteger ,
      @inicio udtDateTime ,
      @cierre udtDateTime
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY
    
    DECLARE @Row udtInteger
    
    SET @Row = ( SELECT COUNT(1)
                 FROM   dbo.Obras_FromFile
                 WHERE  codigo = @codigo
                        AND periodo = @periodo
                        AND mes = @mes
                        AND ayo = @ayo
                        AND empresa = @empresa
               )
    
    IF @Row >= 1 
        BEGIN
            PRINT 'Exsite'
            UPDATE  dbo.Obras_FromFile
            SET     dias = @dias
            WHERE   codigo = @codigo
                    AND periodo = @periodo
                    AND ayo = @ayo
                    AND mes = @mes
                    AND empresa = @empresa
        END
    ELSE 
        BEGIN
            PRINT 'No Exsite'
            INSERT  INTO dbo.Obras_FromFile
                    ( Obra ,
                      empresa ,
                      codigo ,
                      dias ,
                      mes ,
                      ayo ,
                      periodo ,
                      inicio ,
                      cierre
				
                    )
                    SELECT  @Obra ,
                            a.empresa ,
                            @codigo ,
                            @dias ,
                            @mes ,
                            @ayo ,
                            @periodo ,
                            @inicio ,
                            @cierre
                    FROM    dbo.empleados AS a
                    WHERE   a.codigo = @codigo
                            AND a.empresa = @empresa

        END
	        
	        
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenObrasParametros'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenObrasParametros
    
GO


CREATE PROCEDURE dbo.ObtenObrasParametros ( @empresa udtInteger )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY
    
    SELECT  *
    FROM    dbo.Obras_param
    WHERE   empresa = @empresa
	        
	        
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ModificaPortalIndParametros'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ModificaPortalIndParametros
    
GO


CREATE PROCEDURE dbo.ModificaPortalIndParametros
    (
      @empresa udtInteger ,
      @carga udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY
    
    DECLARE @Row udtInteger
    
    SET @Row = ( SELECT COUNT(1)
                 FROM   dbo.Obras_param
                 WHERE  empresa = @empresa
               )
    
    IF @Row >= 1 
        BEGIN
            UPDATE  dbo.Obras_param
            SET     tipo_carga = @carga
            WHERE   empresa = @empresa 
        END
    ELSE 
        BEGIN
            INSERT  INTO dbo.Obras_param
                    ( empresa, tipo_carga )
            VALUES  ( @empresa, @carga )
        END
	        
	        
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenDetalleObraIncidencia'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenDetalleObraIncidencia
    
GO


CREATE PROCEDURE dbo.ObtenDetalleObraIncidencia
    (
      @empresa udtInteger ,
      @workId udtLong
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    SELECT  b.nombre_empresa ,
            b.registro_patronal ,
            a.obra ,
            a.localidad ,
            a.municipio ,
            a.ent_fed
    FROM    dbo.Obras AS a
            INNER JOIN dbo.empresas AS b ON a.empresa = b.empresa
    WHERE   a.empresa = @empresa
            AND a.obra = @workId


GO


IF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'Obras_CentrosRelacion')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 ) 
    CREATE TABLE [dbo].[Obras_CentrosRelacion]
        (
          [Obra] [numeric](18, 0) NOT NULL ,
          [empresa] [numeric](3, 0) NOT NULL ,
          [clave] [VarChar](15) NOT NULL ,
          [nombre] [VarChar](50) NULL ,
          CONSTRAINT [PK_Obras_Relacion] PRIMARY KEY CLUSTERED
            ( [clave] ASC, [Obra] ASC, [empresa] ASC )
        )
    ON  [PRIMARY]

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.ObtenObrasRelacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.ObtenObrasRelacion
    
GO


CREATE PROCEDURE dbo.ObtenObrasRelacion ( @empresa udtInteger )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY
    
    SELECT  clave ,
            nombre ,
            REPLICATE('0', 12 - LEN(Obra))
            + RTRIM(LTRIM(CAST(Obra AS VARCHAR(20)))) AS obra
    FROM    dbo.Obras_CentrosRelacion
    WHERE   empresa = @empresa
	        
	        
GO

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.AgregaPortalIndObrasRelacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.AgregaPortalIndObrasRelacion
    
GO


CREATE PROCEDURE dbo.AgregaPortalIndObrasRelacion
    (
      @empresa udtInteger ,
      @obra udtLong ,
      @clave udtLong ,
      @nombre udtName
      
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY
    
    INSERT  INTO dbo.Obras_CentrosRelacion
            ( Obra, empresa, clave, nombre )
    VALUES  ( @obra, -- Obra - numeric
              @empresa, -- empresa - numeric
              @clave, -- clave - varchar(15)
              @nombre  -- nombre - varchar(50)
              )
                            
GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.BorraPortalIndObrasRelacion')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.BorraPortalIndObrasRelacion
    
GO

CREATE PROCEDURE dbo.BorraPortalIndObrasRelacion
    (
      @empresa udtInteger ,
      @obra udtLong ,
      @clave udtName 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY
    
    DELETE  dbo.Obras_CentrosRelacion
    WHERE   empresa = @empresa
            AND Obra = @obra
            AND clave = @clave
    
                            
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenPortalConsCategorias'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenPortalConsCategorias
    
GO

CREATE PROCEDURE dbo.ObtenPortalConsCategorias ( @type udtInteger )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    SET @debug = 0
    
    SET @selectClause = CASE WHEN @type = 1
                             THEN 'select replicate(''0'',2-len(a.categoria)) + ltrim(CONVERT(BIGINT,a.categoria)) as categoria, '
                             ELSE 'select replicate(''0'',2-len(a.sub_categoria)) + ltrim(CONVERT(BIGINT,a.sub_categoria)) as categoria, '
                        END + 'a.nombre as Nombre '
    SET @fromClause = 'From '
        + CASE WHEN @type = 1 THEN 'dbo.Obras_Categorias as a '
               ELSE 'dbo.Obras_SubCategorias as a '
          END 
    SET @whereClause = '' 
    SET @groupByClause = ''
	
    SET @orderByClause = ''
    
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
    
GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'AgregaPortalConsEmpleadosCategorias'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.AgregaPortalConsEmpleadosCategorias
    
GO

CREATE PROCEDURE dbo.AgregaPortalConsEmpleadosCategorias ( @empresa udtInteger )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    INSERT  INTO dbo.Obras_EmpleadosCategorias
            ( empresa ,
              codigo ,
              categoria ,
              sub_categoria
            )
            SELECT  a.empresa ,
                    a.codigo ,
                    1 AS categoria ,
                    1 AS subcategoria
            FROM    dbo.empleados AS a
                    LEFT JOIN dbo.Obras_EmpleadosCategorias AS b ON a.empresa = b.empresa
                                                              AND a.codigo = b.codigo
            WHERE   a.empresa = @empresa
                    --AND a.activo = 'S'
                    --AND a.ultmov <> 'B'
                    AND b.codigo IS NULL
            ORDER BY a.codigo
    
GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'ObtenPortalConsEmpsCategorias'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.ObtenPortalConsEmpsCategorias
    
GO

CREATE PROCEDURE dbo.ObtenPortalConsEmpsCategorias
    (
      @empresa udtInteger ,
      @categoria udtInteger ,
      @type udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT DMY

    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @debug udtInteger
    
    SET @debug = 0
    
    SET @selectClause = 'select a.codigo, '
        + 'rtrim(ltrim(a.ap_paterno)) + '' '' + rtrim(ltrim(a.ap_materno)) + '' '' + rtrim(ltrim(a.nombre)) Nombre, '
        + ' '' ''as sel,''N'' as sel2 '
    SET @fromClause = 'From dbo.empleados as a '
        + 'INNER JOIN dbo.Obras_EmpleadosCategorias as b ON a.empresa=b.empresa AND a.codigo=b.codigo '
    SET @whereClause = 'WHERE a.empresa = ' + RTRIM(LTRIM(STR(@empresa)))
        + ' AND ' + CASE WHEN @type = 1 THEN 'b.categoria = '
                         ELSE 'b.sub_categoria = '
                    END + RTRIM(LTRIM(STR(@categoria)))
    SET @groupByClause = ''
	
    SET @orderByClause = ''
    
    IF @debug = 0 
        BEGIN
            EXEC(
            @selectClause +
            @fromClause +
            @whereClause +
            @groupByClause +
            @orderByClause
            )
        END
    ELSE 
        BEGIN
            PRINT ( @selectClause + @fromClause + @whereClause
                    + @groupByClause + @orderByClause )
        END
    
GO

IF NOT EXISTS ( SELECT  1
                FROM    dbo.Obras_Categorias
                WHERE   categoria = 1 ) 
    BEGIN
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 1, 'AYUDANTE' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 2, 'AYUDANTES CALIFICADOS' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 3, 'OFICIALES' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 4, 'OFICIALES CALIFICADOS' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 5, 'OPERADORES' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 6, 'PEONES' )
        INSERT  INTO dbo.Obras_Categorias
                ( categoria, nombre )
        VALUES  ( 7, 'SUPERVISORES' )

    END


GO

IF NOT EXISTS ( SELECT  1
                FROM    dbo.Obras_SubCategorias
                WHERE   sub_categoria = 1 ) 
    BEGIN
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 1, 'Ayudante' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 2, 'Ayudante de Aforador' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 3, 'Ayudante de Albailera' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 4, 'Ayudante de Aluminero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 5, 'Ayudante de Azulejero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 6, 'Ayudante de Cantero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria ,
                  nombre
                )
        VALUES  ( 7 ,
                  'Ayudante de Carpintero de Banco'
                )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria ,
                  nombre
                )
        VALUES  ( 8 ,
                  'Ayudante de Carpintero de Obra Negra'
                )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 9, 'Ayudante de Elctrico' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 10, 'Ayudante de Fierrero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 11, 'Ayudante de Herrero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 12, 'Ayudante de Instalacin' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 13, 'Ayudante de Jardinero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 14, 'Ayudante de Mosaiquero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 15, 'Ayudante de Operador' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 16, 'Ayudante de Pastero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria ,
                  nombre
                )
        VALUES  ( 17 ,
                  'Ayudante de Perforador (chango)'
                )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 18, 'Ayudante de Pintor' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 19, 'Ayudante de Piso' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 20, 'Ayudante de Plomero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 21, 'Ayudante de Radiolgo' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 22, 'Ayudante de Topgrafo' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 23, 'Ayudante de Tubero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 24, 'Ayudante de Vidriero' )
        INSERT  INTO dbo.Obras_SubCategorias
                ( sub_categoria, nombre )
        VALUES  ( 25, 'Ayudante de Yesero' )

    END


GO


IF OBJECT_ID('dbo.ObtenPortalCons_EmpleadosPorObra') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalCons_EmpleadosPorObra
go


CREATE PROCEDURE dbo.ObtenPortalCons_EmpleadosPorObra
--Declare 
    @Empresa INT ,
	@obra varchar(50),
    @Mes INT ,
    @Ayo INT
AS

	select	a.codigo,
			rtrim(b.ap_paterno) + ' ' + RTRIM(b.ap_materno) + ' ' + RTRIM(b.nombre) as nombre,
			convert(nvarchar(12),a.fecha_i,103) as Inicio,
			convert(nvarchar(12),a.fecha_f,103) as Termino,
			a.dias,
			convert(nvarchar(12),a.fecha_i,112) as Inicio2,
			convert(nvarchar(12),a.fecha_f,112) as Termino2
	from dbo.Obras_emps as a
	inner join dbo.empleados as b on b.empresa=a.empresa and b.codigo=a.codigo
	where	a.empresa=@empresa
			and a.obra=@obra
			and a.mes=@mes
			and a.ayo=@Ayo

GO

IF OBJECT_ID('dbo.PortalCons_EliminaMovimientos') IS NOT NULL 
    DROP PROCEDURE dbo.PortalCons_EliminaMovimientos
go


CREATE PROCEDURE dbo.PortalCons_EliminaMovimientos
--Declare 
    @Empresa INT ,
	@Mes INT ,
    @Ayo INT
AS

	delete a
	from dbo.Obras_emps as a
	where	a.empresa=@empresa
			and a.mes=@mes
			and a.ayo=@Ayo

	update a set dias_disponibles = dias
	from dbo.trabajadores_mes as a
	where	a.empresa=@empresa
			and a.mes=@mes
			and a.ayo=@Ayo

GO

IF OBJECT_ID('dbo.ObtenPortalCons_ValoresFiltros') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalCons_ValoresFiltros
go

CREATE PROCEDURE dbo.ObtenPortalCons_ValoresFiltros
--Declare 
    @Empresa INT ,
	@Mes INT ,
    @Ayo INT,
	@Tipo int
AS
 
	select * 
	from 
	(select	distinct case when @Tipo = 1 then l.centro else cast(l.supervisor as Varchar(50)) end  as valor,
			case when @Tipo = 1 then rtrim(c.nomdepto) else rtrim(s.nombre) end  as Nombre,
			dbo.padl(null,case when @Tipo = 1 then l.centro else cast(l.supervisor as Varchar(50)) end,20,'0') as ParaOrden
	from dbo.trabajadores_mes as a
	inner join dbo.llaves as l on l.empresa=a.empresa and l.codigo = a.codigo
	inner join dbo.supervisores as s on s.empresa=l.empresa and s.supervisor =l.supervisor
	inner join dbo.centros as c on c.empresa=l.empresa and c.centro=l.centro
	where	a.empresa=@empresa
			and a.mes=@mes
			and a.ayo=@Ayo
	) as tbl 
	order by paraorden

go

IF OBJECT_ID('dbo.ObtenPortalCons_EmpleadosDisponibles') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalCons_EmpleadosDisponibles
go

CREATE PROCEDURE dbo.ObtenPortalCons_EmpleadosDisponibles
--Declare 
    @Empresa INT ,
    @Mes INT ,
    @Ayo INT,
	@Tipo int,
	@centro varchar(20),
	@supervisor bigint,
	@Disponibles int
AS
 
	select * 
	from 
	(select	a.empresa,
			a.codigo,
			rtrim(b.ap_paterno) + ' ' + RTRIM(b.ap_materno) + ' ' + RTRIM(b.nombre) as nombre,
			convert(nvarchar(12),a.fch_ini,103) as Inicio,
			convert(nvarchar(12),a.fch_fin,103) as Termino,
			a.dias,
			isnull(ds.dias,0) as asignados,
			a.dias_disponibles as disponibles
	from dbo.trabajadores_mes as a
	inner join dbo.empleados as b on b.empresa=a.empresa and b.codigo=a.codigo
	inner join dbo.llaves as l on l.empresa=a.empresa and l.codigo = a.codigo
	left join (select z.empresa, z.codigo, sum(z.dias) as dias
				from Obras_emps as z 
				where z.empresa=@empresa and z.mes=@mes and z.ayo=ayo 
				group by z.empresa,z.codigo) as ds on ds.empresa=a.empresa and ds.codigo=a.empresa
	where	a.empresa=@empresa
			and a.mes=@mes
			and a.ayo=@Ayo
			and case when @Tipo = 1 then l.centro else '' end = case when @Tipo = 1 then @centro else '' end
			and case when @Tipo = 2 then l.supervisor else 0 end = case when @Tipo = 2 then @supervisor else 0 end
	) as tbl 
	where case when @Disponibles = 1 then disponibles else 1 end > 0

go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_AsignaDias'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_AsignaDias
GO

CREATE PROCEDURE dbo.PortalCons_AsignaDias
    (
		@Empresa INT ,
		@obra varchar(50),
		@Mes INT ,
		@Ayo INT,
		@inicio datetime,
		@termino datetime,
		@codigos varchar(max)
    )
    --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	declare @sql varchar(max)
	set  @sql = 'Select empresa,codigo,fch_ini,fch_fin,dias_disponibles from dbo.trabajadores_mes where dias_disponibles >0 and empresa= ' + rtrim(ltrim(cast(@empresa as varchar(10)))) + 'and mes=' +rtrim(ltrim(cast(@mes as varchar(10)))) + ' and ayo=' + rtrim(ltrim(cast(@Ayo as varchar(10)))) + ' and codigo in('
	declare @Empleados as table(empresa int, codigo int, inicio datetime, termino datetime, disponibles int)
	
	insert into @Empleados(empresa, codigo, inicio, termino, disponibles)
	exec(@sql + @codigos + ')')

	declare @fechaMet datetime
	set @fechaMet = @inicio
	declare @fechas as table(empresa int, codigo int, fecha datetime)

	while @fechaMet <= @termino
	begin
		
		insert into @fechas
		select	a.empresa,
				a.codigo,
				@fechaMet as fecha
		from @Empleados as a
		where ( @fechaMet >= a.inicio AND @fechaMet <= a.termino) OR ( @fechaMet < a.inicio AND (@fechaMet >= a.inicio AND a.termino <= @fechaMet))
													OR ( @fechaMet < a.inicio AND ( @fechaMet >= a.inicio AND @fechaMet >= a.termino))
													OR ( @fechaMet >= a.inicio AND @fechaMet <= a.termino)
		
		set @fechaMet = @fechaMet + 1
	end
	declare @incluir as table(empresa int, codigo int)
	insert into @incluir
	select empresa,codigo
	from @fechas
	group by empresa,codigo

	declare @NoEntran as table(empresa int,codigo bigint)

	insert into @NoEntran
	select a.empresa,a.codigo
	from dbo.Obras_emps as a
	inner join @Empleados as b on b.empresa=a.empresa and b.codigo = a.codigo
	where	a.empresa = @empresa
			and a.mes = @Mes
			and a.ayo = @Ayo
			and (a.fecha_i between @inicio and @termino
				or a.fecha_f between @inicio and @termino)

	declare @validos as table(empresa int, codigo int, inicio datetime, termino datetime, dias int)

	insert into @validos
	select empresa,codigo,inicio,termino,DATEDIFF(day,inicio,termino) + 1 as dias
	from (
			select a.empresa,a.codigo,case when a.fch_ini > @inicio then a.fch_ini else @inicio end as inicio, case when a.fch_fin <= @termino then a.fch_fin else @termino end as termino
			from dbo.trabajadores_mes as a
			inner join @Empleados as b on b.empresa=a.empresa and b.codigo = a.codigo
			where	a.empresa = @empresa
					and a.mes = @Mes
					and a.ayo = @Ayo
					and a.codigo not in(select codigo from @NoEntran)
					and a.codigo in(select codigo from @incluir)
		) as tbl

		update a set dias_disponibles = a.dias_disponibles - b.dias
		from dbo.trabajadores_mes as a
		inner join @validos as b on b.empresa=a.empresa and b.codigo = a.codigo
		where	a.empresa = @empresa
					and a.mes = @Mes
					and a.ayo = @Ayo

		insert into dbo.Obras_emps(Obra, empresa, codigo, fecha_i, fecha_f, supervisor, dias, mes, ayo, saldiaint, sueldo)
		select	@obra as obra,
				a.empresa,
				a.codigo,
				a.inicio,
				a.termino,
				c.supervisor,
				a.dias,
				@mes as mes,
				@Ayo as ayo,
				b.saldiaint,
				b.sueldo
		from @validos as a
		inner join empleados as b on b.empresa=a.empresa and a.codigo=b.codigo
		inner join llaves as c on c.empresa=a.empresa and c.codigo=b.codigo

		select a.codigo,
				rtrim(b1.nombre) + ' ' + rtrim(b1.ap_paterno) + ' ' + rtrim(b1.ap_materno) as nombre
		from @empleados as a
		inner join dbo.empleados as b1 on b1.empresa=@empresa and b1.codigo=a.codigo
		left join @incluir as b on b.empresa=a.empresa and b.codigo = a.codigo
		left join @NoEntran as c on c.empresa=a.empresa and c.codigo = a.codigo
		where not c.codigo is null or b.codigo is null
		group by a.empresa,a.codigo,rtrim(b1.nombre) + ' ' + rtrim(b1.ap_paterno) + ' ' + rtrim(b1.ap_materno)
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO


IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_DetalleEmp'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_DetalleEmp
GO

CREATE PROCEDURE dbo.PortalCons_DetalleEmp
    (
		@Empresa INT ,
		@codigo bigint,
		@Mes INT ,
		@Ayo INT
    )
    --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	select	a.obra,
			b.nombre,
			convert(nvarchar(12),a.fecha_i,112) as Inicio,
			convert(nvarchar(12),a.fecha_f,112) as Termino,
			a.dias
	from dbo.Obras_emps as a
	inner join dbo.obras as b on b.empresa=a.empresa and b.obra=a.Obra
	where a.empresa=@Empresa and a.mes=@Mes and a.ayo =@Ayo and a.codigo=@codigo
	order by a.fecha_i asc

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_ModificaMovimiento'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_ModificaMovimiento
GO

CREATE PROCEDURE dbo.PortalCons_ModificaMovimiento
    (
		@Empresa INT ,
		@codigo bigint,
		@Mes INT ,
		@Ayo INT,
		@del datetime,
		@al datetime,
		@obra varchar(50)
    )
    --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	update dbo.Obras_emps set obra=@obra
	where empresa=@Empresa and mes=@Mes and ayo =@Ayo and codigo=@codigo and fecha_i=@del and fecha_f = @al

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_EliminaMovimiento'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_EliminaMovimiento
GO

CREATE PROCEDURE dbo.PortalCons_EliminaMovimiento
    (
		@Empresa INT ,
		@codigo bigint,
		@Mes INT ,
		@Ayo INT,
		@del datetime,
		@al datetime
    )
    --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
	
	declare @dias int
	
	select @dias=dias
	from dbo.Obras_emps 
	where empresa=@Empresa and mes=@Mes and ayo =@Ayo and codigo=@codigo and fecha_i=@del and fecha_f = @al
	
	update a set dias_disponibles = a.dias_disponibles + @dias
	from dbo.trabajadores_mes as a
	where a.empresa=@Empresa and a.mes=@Mes and a.ayo =@Ayo and a.codigo=@codigo

	delete dbo.Obras_emps 
	where empresa=@Empresa and mes=@Mes and ayo =@Ayo and codigo=@codigo and fecha_i=@del and fecha_f = @al

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_Obra'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_Obra
GO

CREATE PROCEDURE dbo.PortalCons_Obra
    (
		@obra varchar(50), 
		@empresa int, 
		@nombre varchar(50), 
		@razon_social varchar(70), 
		@registro_patronal varchar(11), 
		@calle varchar(30), 
		@n_interior int, 
		@n_exterior int, 
		@colonia varchar(30), 
		@municipio varchar(30), 
		@cp int, 
		@localidad varchar(30), 
		@ent_fed varchar(30), 
		@estatus varchar(2)
    )
    --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
	
	if isnull((select sum(1) from dbo.Obras where empresa=1 and obra=@obra),0)<=0
	begin
		insert into dbo.Obras(obra, empresa, nombre, razon_social, registro_patronal, calle, n_interior, n_exterior, colonia, municipio, cp, localidad, ent_fed, estatus) values
							 (@obra, @empresa, @nombre, @razon_social, @registro_patronal, @calle, @n_interior, @n_exterior, @colonia, @municipio, @cp, @localidad, @ent_fed, @estatus)
	end 
	else begin
		update dbo.Obras set nombre=@nombre, razon_social=@razon_social, registro_patronal=@registro_patronal, calle=@calle, n_interior=@n_interior, n_exterior=@n_exterior, colonia=@colonia, municipio=@municipio, cp=@cp, localidad=@localidad, ent_fed=@ent_fed, estatus=@estatus
		where	empresa=@empresa
				and obra=@obra
	end


END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_TotalDias'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_TotalDias
GO

CREATE PROCEDURE dbo.PortalCons_TotalDias
    (
		@Empresa INT ,
		@Mes INT ,
		@Ayo INT
    )
    --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY
	
	Select sum(dias) as dias, sum(dias) - sum(isnull(dias_disponibles,0)) as Asignados, sum(isnull(dias_disponibles,0)) as Disponibles
	from dbo.trabajadores_mes as a
	where a.empresa=@Empresa and a.mes=@Mes and a.ayo =@Ayo


END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_ObrasReportes'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_ObrasReportes
GO

CREATE PROCEDURE dbo.PortalCons_ObrasReportes
    (
		@Empresa INT ,
		@mes1 INT ,
		@mes2 INT ,
		@Ayo INT,
		@Tipo int 
    )
    --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY


	select	a.obra,
			b.nombre
	from dbo.Obras_emps as a
	inner join dbo.Obras as b on b.empresa = a.empresa and b.obra=a.obra
	where	a.empresa=@empresa 
			and a.ayo = @Ayo
			and a.mes in(@mes1,@mes2)
	group by a.Obra,b.nombre

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_ReporteDias'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_ReporteDias
    
GO

CREATE PROCEDURE dbo.PortalCons_ReporteDias
    (
      @empresa int ,
      @obra varchar(50) ,
      @mes1 int ,
	  @mes2 int ,
      @ayo int,
      @tipo int,
	  @Bimestre int
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	Declare @ObrasEmps as table(empresa int, obra varchar(50),codigo bigint, dias int, incio datetime, termino datetime, mes int, ayo int)
	insert into @ObrasEmps
	select	a.empresa,
			a.obra,
			a.codigo,
			a.dias,
			a.fecha_i,
			a.fecha_f,
			a.mes,
			a.ayo
	from dbo.Obras_emps as a
	where	a.empresa=@empresa 
			and a.ayo = @Ayo
			and a.mes in(@mes1,@mes2)
			and a.obra = @obra

	select obra,
			Nombre,
			Afiliacion,
			dMes1,
			dMes2,
			nombre_empresa,
			Bimestre,
			ayo,
			(dMes1 + dMes2) * saldiaint as importe,
			saldiaint,
			currentDay,
			currentMonth,
			currentYear,
			Categoria,
			Sub_Categoria
	from(
			select	dbo.padl(null,rtrim(a.obra),12,'0') as Obra,
					a.codigo,
					rtrim(b.ap_paterno) + ' ' + rtrim(b.ap_materno) + ' ' + rtrim(b.nombre) as Nombre,
					max(b.afiliacion+b.digvera) as Afiliacion,
					sum(case when a.mes=@mes1 then a.dias else 0 end) as dMes1,
					sum(case when a.mes=@mes2 and @tipo=1 then a.dias else 0 end) as dMes2,
					max(emp.nombre_empresa) as nombre_empresa,
					@Bimestre as Bimestre,
					@ayo as ayo,
					max(b.saldiaint) as saldiaint,
					REPLICATE('0',2-LEN(DAY(GETDATE()))) + LTRIM(STR(DAY(GETDATE()))) AS currentDay,
					REPLICATE('0',2-LEN(MONTH(GETDATE()))) + LTRIM(STR(MONTH(GETDATE()))) AS currentMonth,
					REPLICATE('0',4-LEN(year(GETDATE()))) + LTRIM(STR(year(GETDATE()))) AS currentYear,
					max(d.nombre) as Categoria,
					max(f.nombre) as Sub_Categoria
			from @obrasEmps as a
			inner join dbo.empresas as emp on emp.empresa=a.empresa
			inner join dbo.empleados as b on b.empresa = a.empresa and b.codigo=a.codigo
			Left join dbo.Obras_EmpleadosCategorias as c on a.empresa=c.empresa and a.codigo=c.codigo 
			inner join dbo.Obras_Categorias as d on d.categoria=c.categoria 
			inner join dbo.Obras_SubCategorias as f on f.sub_categoria=c.sub_categoria  
			where	a.empresa=@empresa
					and a.ayo = @Ayo
					and a.mes in(@mes1,@mes2)
					and a.obra = @obra
			group by a.obra,
					 a.codigo,
					rtrim(b.ap_paterno) + ' ' + rtrim(b.ap_materno) + ' ' + rtrim(b.nombre)
		) as Tbl
		order by codigo

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_ReporteCostoObra'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_ReporteCostoObra
    
GO

CREATE PROCEDURE dbo.PortalCons_ReporteCostoObra
    (
      @empresa int ,
      @obra varchar(50) ,
      @mes1 int ,
	  @mes2 int ,
      @ayo int,
	  @Bimestre int
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	Declare @ObrasEmps as table(empresa int, obra varchar(50),codigo bigint, dias int, incio datetime, termino datetime, mes int, ayo int)
	insert into @ObrasEmps
	select	a.empresa,
			a.obra,
			a.codigo,
			a.dias,
			a.fecha_i,
			a.fecha_f,
			a.mes,
			a.ayo
	from dbo.Obras_emps as a
	where	a.empresa=@empresa 
			and a.ayo = @Ayo
			and a.mes in(@mes1,@mes2)
			and a.obra = @obra

	select  dense_rank() OVER ( PARTITION  BY empresa ORDER BY codigo ) as 'No.',
			Nombre,
			dMes1 as 'Dias Mes 1',
			dMes2 as 'Dias Mes 2',
			saldiaint as 'SBC',
			(dMes1 + dMes2) * saldiaint as 'SDI * Dias Bim'
	from(
			select	a.empresa,
					a.codigo,
					--dense_rank() OVER ( PARTITION  BY a.codigo ORDER BY a.empresa ) as Num,
					rtrim(b.ap_paterno) + ' ' + rtrim(b.ap_materno) + ' ' + rtrim(b.nombre) as Nombre,
					sum(case when a.mes=@mes1 then a.dias else 0 end) as dMes1,
					sum(case when a.mes=@mes2 then a.dias else 0 end) as dMes2,
					max(b.saldiaint) as saldiaint
			from @obrasEmps as a
			inner join dbo.empleados as b on b.empresa = a.empresa and b.codigo=a.codigo
			where	a.empresa=@empresa
					and a.ayo = @Ayo
					and a.mes in(@mes1,@mes2)
					and a.obra = @obra
			group by	a.empresa,
						a.codigo,
						rtrim(b.ap_paterno) + ' ' + rtrim(b.ap_materno) + ' ' + rtrim(b.nombre)
						--dense_rank() OVER ( PARTITION  BY a.codigo ORDER BY a.empresa ) 
		) as Tbl
		order by codigo

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_ReporteArchivoDias'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_ReporteArchivoDias
    
GO

CREATE PROCEDURE dbo.PortalCons_ReporteArchivoDias
    (
      @empresa int ,
      @obra varchar(50) ,
      @mes1 int ,
	  @mes2 int ,
      @ayo int,
	  @Bimestre int
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	Declare @ObrasEmps as table(empresa int, obra varchar(50),codigo bigint, dias int, incio datetime, termino datetime, mes int, ayo int)
	insert into @ObrasEmps
	select	a.empresa,
			a.obra,
			a.codigo,
			a.dias,
			a.fecha_i,
			a.fecha_f,
			a.mes,
			a.ayo
	from dbo.Obras_emps as a
	where	a.empresa=@empresa 
			and a.ayo = @Ayo
			and a.mes in(@mes1,@mes2)
			and a.obra = @obra

	select	dense_rank() OVER ( PARTITION  BY empresa ORDER BY codigo ) as Numero,
			Nombre,
			Afiliacion as'NSS',
			dMes1 as 'Das trabajados mes 1',
			dMes2 as 'Das trabajados mes 2',
			Categoria,
			Sub_Categoria,
			saldiaint,
			(dMes1 + dMes2) * saldiaint as importe
	from(
			select	a.empresa,
					a.codigo,
					rtrim(b.ap_paterno) + ' ' + rtrim(b.ap_materno) + ' ' + rtrim(b.nombre) as Nombre,
					max(b.afiliacion+b.digvera) as Afiliacion,
					sum(case when a.mes=@mes1 then a.dias else 0 end) as dMes1,
					sum(case when a.mes=@mes2 then a.dias else 0 end) as dMes2,
					max(b.saldiaint) as saldiaint,
					max(d.nombre) as Categoria,
					max(f.nombre) as Sub_Categoria
			from @obrasEmps as a
			inner join dbo.empresas as emp on emp.empresa=a.empresa
			inner join dbo.empleados as b on b.empresa = a.empresa and b.codigo=a.codigo
			Left join dbo.Obras_EmpleadosCategorias as c on a.empresa=c.empresa and a.codigo=c.codigo 
			inner join dbo.Obras_Categorias as d on d.categoria=c.categoria 
			inner join dbo.Obras_SubCategorias as f on f.sub_categoria=c.sub_categoria  
			where	a.empresa=@empresa
					and a.ayo = @Ayo
					and a.mes in(@mes1,@mes2)
					and a.obra = @obra
			group by	a.empresa,
						a.codigo,
						rtrim(b.ap_paterno) + ' ' + rtrim(b.ap_materno) + ' ' + rtrim(b.nombre)
						--dense_rank() OVER ( PARTITION  BY a.codigo ORDER BY a.empresa ) 
		) as Tbl
		order by codigo

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_ReportePorFechas'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_ReportePorFechas
    
GO

CREATE PROCEDURE dbo.PortalCons_ReportePorFechas
    (
      @empresa int ,
      @obra varchar(50) ,
      @mes int ,
	  @ayo int
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	Declare @ObrasEmps as table(empresa int, obra varchar(50),codigo bigint, dias int, inicio datetime, termino datetime, mes int, ayo int)
	insert into @ObrasEmps
	select	a.empresa,
			a.obra,
			a.codigo,
			a.dias,
			a.fecha_i,
			a.fecha_f,
			a.mes,
			a.ayo
	from dbo.Obras_emps as a
	where	a.empresa=@empresa 
			and a.ayo = @Ayo
			and a.mes in(@mes)
			and a.obra = @obra

	select	dense_rank() OVER ( PARTITION  BY empresa ORDER BY codigo ) as Numero,
			codigo as 'Cdigo',
			Nombre,
			Afiliacion as'NSS',
			Inicio,
			Termino,
			Dias
	from(
			select	a.empresa,
					a.codigo,
					rtrim(b.ap_paterno) + ' ' + rtrim(b.ap_materno) + ' ' + rtrim(b.nombre) as Nombre,
					b.afiliacion+b.digvera as Afiliacion,
					a.dias,
					convert(nvarchar(12),a.Inicio,103) as Inicio,
					convert(nvarchar(12),a.Termino,103) as Termino
			from @obrasEmps as a
			inner join dbo.empresas as emp on emp.empresa=a.empresa
			inner join dbo.empleados as b on b.empresa = a.empresa and b.codigo=a.codigo
			--Left join dbo.Obras_EmpleadosCategorias as c on a.empresa=c.empresa and a.codigo=c.codigo 
			--inner join dbo.Obras_Categorias as d on d.categoria=c.categoria 
			--inner join dbo.Obras_SubCategorias as f on f.sub_categoria=c.sub_categoria  
			where	a.empresa=@empresa
					and a.ayo = @Ayo
					and a.mes = @mes
					and a.obra = @obra
		) as Tbl
		order by codigo, inicio

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_EmpleadosActivos'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_EmpleadosActivos
    
GO

CREATE PROCEDURE dbo.PortalCons_EmpleadosActivos
    (
      @empresa int
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	Select	a.codigo,
			rtrim(a.ap_paterno) + ' ' + rtrim(a.ap_materno) + ' ' + rtrim(a.nombre) as Nombre,
			isnull(b.SinObra,0) as SinObra
	from dbo.empleados as a
	left join dbo.Obras_SinObra as b on b.empresa = a.empresa and b.codigo = a.codigo
	where	a.empresa=@empresa
			and a.activo='S'
			and a.borrado <>'S'

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_EmpleadosSinObra'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_EmpleadosSinObra
    
GO

CREATE PROCEDURE dbo.PortalCons_EmpleadosSinObra
    (
      @empresa int,
	  @codigo bigint,
	  @valor int
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	if isnull((select 1 from dbo.Obras_SinObra where empresa=@empresa and codigo=@codigo),0)<=0
	begin
		insert into dbo.Obras_SinObra(empresa,codigo,SinObra)values(@empresa,@codigo,0)
	end
	
	update dbo.Obras_SinObra set SinObra = @valor where empresa=@empresa and codigo = @codigo

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_BuscaMes'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_BuscaMes
    
GO

CREATE PROCEDURE dbo.PortalCons_BuscaMes
    (
		@empresa NUMERIC(5, 0) ,
		@mes INT ,
		@ayo INT 
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	if isnull((select top 1 1 from trabajadores_mes where empresa=@empresa and mes=@mes and ayo = @ayo),0) <=0
	begin
		exec dbo.asp_trabajadores_del_mes @empresa,@mes,@ayo,'N'
	end 	
	select isnull((select top 1 'Continua' from trabajadores_mes where empresa=@empresa and mes=@mes and ayo = @ayo),'No') as Respuesta
END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_EmpleadosDifCategoria'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_EmpleadosDifCategoria
    
GO

CREATE PROCEDURE dbo.PortalCons_EmpleadosDifCategoria
    (
		@empresa NUMERIC(5, 0) ,
		@categoria bigint,
		@Tipo INT,
		@Filtro int,
		@centro varchar(50),
		@supervisor int
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

		select	a.codigo,
				rtrim(a.ap_paterno) + ' ' + rtrim(a.ap_materno) + ' ' + rtrim(a.nombre) as Nombre
		from dbo.empleados as a
		left join dbo.obras_empleadoscategorias as b on b.empresa=a.empresa and a.codigo=b.codigo
		inner join dbo.llaves as l on l.empresa=a.empresa and l.codigo = a.codigo
		where	a.empresa=@empresa
				and case when @tipo=1 then isnull(b.categoria,0) else isnull(b.sub_categoria,0) end <> @categoria
				and a.activo = 'S'
				and case when @Filtro = 1 then l.centro else '' end = case when @Filtro = 1 then @centro else '' end
				and case when @Filtro = 2 then l.supervisor else 0 end = case when @Filtro = 2 then @supervisor else 0 end

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_EmpleadosModificaCategoria'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_EmpleadosModificaCategoria
    
GO

CREATE PROCEDURE dbo.PortalCons_EmpleadosModificaCategoria
    (
		@empresa NUMERIC(5, 0) ,
		@codigo bigint,
		@categoria bigint,
		@Tipo INT 
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

		if isnull((select 1 from dbo.Obras_EmpleadosCategorias where empresa=@empresa and codigo=@codigo),0)<=0
		begin
			insert into dbo.Obras_EmpleadosCategorias(empresa,codigo,categoria,sub_categoria)values(@empresa,@codigo,1,1)
		end

		if @Tipo = 1 
		begin
			update dbo.Obras_EmpleadosCategorias set categoria = @categoria where empresa=@empresa and codigo=@codigo
		end
		else if @Tipo = 2 
		begin
			update dbo.Obras_EmpleadosCategorias set sub_categoria = @categoria where empresa=@empresa and codigo=@codigo
		end


END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF OBJECT_ID('dbo.ObtenPortalCons_ValoresFiltrosCategorias') IS NOT NULL 
    DROP PROCEDURE dbo.ObtenPortalCons_ValoresFiltrosCategorias
go

CREATE PROCEDURE dbo.ObtenPortalCons_ValoresFiltrosCategorias
--Declare 
    @Empresa INT ,
	@Tipo int
AS
 
	select * 
	from 
	(select	distinct case when @Tipo = 1 then rtrim(l.centro) else rtrim(cast(l.supervisor as Varchar(50))) end  as valor,
			case when @Tipo = 1 then rtrim(c.nomdepto) else rtrim(s.nombre) end  as Nombrevalor,
			dbo.PadL(null,case when @Tipo = 1 then rtrim(l.centro) else rtrim(cast(l.supervisor as Varchar(50))) end,15,'0') as paraOrden
	from dbo.empleados as a
	inner join dbo.llaves as l on l.empresa=a.empresa and l.codigo = a.codigo
	inner join dbo.centros as c on c.empresa=l.empresa and c.centro=l.centro
	inner join dbo.supervisores as s on s.empresa=l.empresa and s.supervisor=l.supervisor
	where	a.empresa=@empresa
			and a.activo = 'S'
	) as tbl 
	order by paraOrden

go

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_ObtenParametros'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_ObtenParametros
    
GO

CREATE PROCEDURE dbo.PortalCons_ObtenParametros
    (
		@empresa NUMERIC(5, 0) 
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

		select	a.empresa,
				case when b.tipo_carga = 1 then 'Nmina' else 'Archivo' end  as TipoCarga,
				isnull(b.tipo_carga,1) as tipo_carga
		from dbo.empresas as a
		inner join dbo.obras_param as b on b.empresa=a.empresa
		where a.empresa=@empresa


END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_ModificaTipoCarga'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_ModificaTipoCarga
    
GO

CREATE PROCEDURE dbo.PortalCons_ModificaTipoCarga
    (
		@empresa NUMERIC(5, 0),
		@TipoCarga int 
    )
        --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

		if isnull((select 1 from dbo.obras_param where empresa=@empresa),0) <=0
		begin
			INSERT INTO dbo.Obras_param(empresa,tipo_carga)values(@empresa,@TipoCarga)
		end

		update dbo.Obras_param set tipo_carga=@TipoCarga where empresa = @empresa


END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO

IF EXISTS ( SELECT  name
            FROM    dbo.sysobjects
            WHERE   name = 'PortalCons_AsignaDiasDesdeArchivo'
                    AND type = 'P' ) 
    DROP PROCEDURE dbo.PortalCons_AsignaDiasDesdeArchivo
GO

CREATE PROCEDURE dbo.PortalCons_AsignaDiasDesdeArchivo
    (
		@Empresa INT ,
		@obra varchar(50),
		@Mes INT ,
		@Ayo INT,
		@inicio datetime,
		@termino datetime,
		@codigo bigint,
		@Dias int
    )
    --WITH ENCRYPTION
AS
	SET NOCOUNT ON
    SET XACT_ABORT ON	
    BEGIN TRANSACTION
    BEGIN TRY

	if ISNULL((select top 1 1 from dbo.obras_emps where empresa=@empresa and codigo = @codigo and fecha_i = @inicio and fecha_f = @termino),0)>0
	begin
		update dbo.obras_emps set dias = @Dias
		where empresa=@empresa and codigo = @codigo and fecha_i = @inicio and fecha_f = @termino
	end 
	else begin 
		insert into dbo.obras_emps(Obra, empresa, codigo, fecha_i, fecha_f, supervisor, dias, mes, ayo, saldiaint, sueldo)
		select	@obra,
				a.empresa,
				a.codigo,
				@inicio,
				@termino,
				b.supervisor,
				@dias,
				@mes,
				@Ayo,
				a.saldiaint,
				a.sueldo
		from dbo.empleados as a
		inner join dbo.llaves as b on b.empresa=a.empresa and b.codigo=a.codigo
		where a.codigo = @codigo
	end

END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
    
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
            
    END CATCH

    IF @@TRANCOUNT > 0 
        COMMIT TRANSACTION 

GO
